Type: Package
Package: maSAE
Title: Mandallaz' Model-Assisted Small Area Estimators
Version: 2.0.3
Authors@R: 
    c(person(given = "Andreas Dominik",
             family = "Cullmann",
             role = c("aut", "cre"),
             email = "fvafrcu@mailbox.org"),
      person(given = "Daniel",
             family = "Mandallaz",
             role = "ctb"),
      person(given = c("Alexander", "Francis"),
             family = "Massey",
             role = "ctb"))
Description: An S4 implementation of the unbiased extension of
    the model- assisted synthetic-regression estimator proposed by
    Mandallaz (2013) <DOI:10.1139/cjfr-2012-0381>, Mandallaz et al. (2013)
    <DOI:10.1139/cjfr-2013-0181> and Mandallaz (2014)
    <DOI:10.1139/cjfr-2013-0449>.  It yields smaller variances than the
    standard bias correction, the generalised regression estimator.
License: BSD_2_clause + file LICENSE
URL: https://gitlab.com/fvafrCU/maSAE
Depends: R (>= 3.6.0)
Imports: methods, stats
Suggests: devtools, forestinventory, JoSAE, knitr, microbenchmark,
        nlme, pkgload, rmarkdown, rprojroot, rsae, RUnit, R.rsp, sae,
        testthat
VignetteBuilder: utils, knitr, R.rsp
RoxygenNote: 7.1.1
NeedsCompilation: no
Packaged: 2021-04-12 09:20:38 UTC; qwer
Author: Andreas Dominik Cullmann [aut, cre],
  Daniel Mandallaz [ctb],
  Alexander Francis Massey [ctb]
Maintainer: Andreas Dominik Cullmann <fvafrcu@mailbox.org>
Repository: CRAN
Date/Publication: 2021-04-12 09:40:02 UTC
Built: R 4.6.0; ; 2026-04-25 20:12:17 UTC; unix

[![pipeline status](https://gitlab.com/fvafrCU/maSAE/badges/master/pipeline.svg)](https://gitlab.com/fvafrCU/maSAE/commits/master)    
[![coverage report](https://gitlab.com/fvafrCU/maSAE/badges/master/coverage.svg)](https://gitlab.com/fvafrCU/maSAE/commits/master)
<!-- 
    [![Build Status](https://travis-ci.org/fvafrCU/maSAE.svg?branch=master)](https://travis-ci.org/fvafrCU/maSAE)
    [![Coverage Status](https://codecov.io/github/fvafrCU/maSAE/coverage.svg?branch=master)](https://codecov.io/github/fvafrCU/maSAE?branch=master)
-->
[![CRAN_Status_Badge](https://www.r-pkg.org/badges/version/maSAE)](https://cran.r-project.org/package=maSAE)
[![RStudio_downloads_monthly](https://cranlogs.r-pkg.org/badges/maSAE)](https://cran.r-project.org/package=maSAE)
[![RStudio_downloads_total](https://cranlogs.r-pkg.org/badges/grand-total/maSAE)](https://cran.r-project.org/package=maSAE)

<!-- README.md is generated from README.Rmd. Please edit that file -->



# maSAE
## Introduction
Please read the
[vignette](https://CRAN.R-project.org/package=maSAE/vignettes/maSAE.pdf).
<!-- 

-->

Or, after installation, the help page:

```r
help("maSAE-package", package = "maSAE")
```

```
#> Mandallaz' Model-Assisted Small Area Estimators
#> 
#> Description:
#> 
#>      An S4 implementation of the unbiased extension of the
#>      model-assisted' synthetic-regression estimator proposed by
#>      Mandallaz (2013), Mandallaz et al. (2013) and Mandallaz (2014).
#>      It yields smaller variances than the standard bias correction, the
#>      generalised regression estimator.
#> 
#> Details:
#> 
#>      This package provides Mandallaz' extended synthetic-regression
#>      estimator for two- and three-phase sampling designs with or
#>      without clustering.
#>      See vignette("maSAE", package = "maSAE") and demo("maSAE", package
#>      = "maSAE") for introductions, '"class?maSAE::saeObj"' and
#>      '"?maSAE::predict"' for help on the main feature.
#> 
#> Note:
#> 
#>      Model-assisted estimators use models to improve the efficiency
#>      (i.e. reduce prediction error compared to design-based estimators)
#>      but need not assume them to be correct as in the model-based
#>      approach, which is advantageous in official statistics.
#> 
#> References:
#> 
#>      Mandallaz, D. 2013 Design-based properties of some small-area
#>      estimators in forest inventory with two-phase sampling. Canadian
#>      Journal of Forest Research *43*(5), pp. 441-449. doi:
#>      \Sexpr[results=rd,stage=build]{tools:::Rd_expr_doi("10.1139/cjfr-2012-0381")}.
#> 
#>      Mandallaz, and Breschan, J.  and Hill, A. 2013 New regression
#>      estimators in forest inventories with two-phase sampling and
#>      partially exhaustive information: a design-based Monte Carlo
#>      approach with applications to small-area estimation. Canadian
#>      Journal of Forest Research *43*(11), pp. 1023-1031. doi:
#>      \Sexpr[results=rd,stage=build]{tools:::Rd_expr_doi("10.1139/cjfr-2013-0181")}.
#> 
#>      Mandallaz, D. 2014 A three-phase sampling extension of the
#>      generalized regression estimator with partially exhaustive
#>      information. Canadian Journal of Forest Research *44*(4), pp.
#>      383-388. doi:
#>      \Sexpr[results=rd,stage=build]{tools:::Rd_expr_doi("10.1139/cjfr-2013-0449")}.
#> 
#> See Also:
#> 
#>      There are a couple packages for model-*based* small area
#>      estimation, see 'sae', 'rsae', hbsae and 'JoSAE'. In 2016, Andreas
#>      Hill published 'forestinventory', another implementation of
#>      Mandallaz' model-assisted small area estimators (see
#>      'vignette("forestinventory_and_maASE", package = "maSAE")' for a
#>      comparison).
#> 
#> Examples:
#> 
#>      ## Not run:
#>      
#>      vignette("maSAE", package = "maSAE")
#>      ## End(Not run)
#>      
#>      ## Not run:
#>      
#>      demo("design", package = "maSAE")
#>      ## End(Not run)
#>      
#>      ## Not run:
#>      
#>      demo("maSAE", package = "maSAE")
#>      ## End(Not run)
#> 
```

## Installation

You can install maSAE from gitlab via:


```r
if (! require("remotes")) install.packages("remotes")
remotes::install_gitlab("fvafrCU/maSAE")
```

clean <- function(x, which = NULL) {
  if (isFALSE(which)) {
    res <- as.matrix(unname(x[TRUE, TRUE]))
  } else {
    if (is.null(which)) {
      if (all(c("small_area", "prediction", "variance") %in% names(x))) {
        res <- as.matrix(unname(x[TRUE, 1:3]))
      } else {
        res <- as.matrix(unname(x[TRUE, c("area", "estimate", "g_variance")]))
      }
    } else {
      res <- as.matrix(unname(x[TRUE, c(1, grep(which, names(x)))]))
    }
  }
  return(res)
}

# I have functions where maSAE and forestinventory get different variances, so I
# would like to check on the predictions at least.
check_variance_prediciton <- function(x, y) {
  prediction_variance <- tryCatch(RUnit::checkIdentical(x, y),
    error = identity
  )
  if (inherits(prediction_variance, "error")) {
    warning("Variances differ, checking for predictions only!", immediate. = TRUE)
    RUnit::checkIdentical(x[, 1:2], y[, 1:2])
  } else {
    RUnit::checkTrue(prediction_variance)
  }
}

message("Tests for the clustered two-phase design")
if (interactive()) {
  pkgload::load_all(".")
  source(file.path(
    devtools::as.package(".")["path"], "inst", "runit_tests",
    "setup.R"
  ))
}
library("forestinventory")
library("maSAE")

clean <- function(x, which = NULL) {
  if (identical(FALSE, which)) {
    res <- as.matrix(unname(x[TRUE, TRUE]))
  } else {
    if (is.null(which)) {
      if (all(c("small_area", "prediction", "variance") %in% names(x))) {
        res <- as.matrix(unname(x[TRUE, 1:3]))
      } else {
        res <- as.matrix(unname(x[["estimation"]][TRUE, c("area", "estimate", "g_variance")]))
      }
    } else {
      res <- as.matrix(unname(x[TRUE, c(1, grep(which, names(x)))]))
    }
  }
  return(res)
}

compare <- function(maSAE, forestinventory, message = NULL) {
  if (!isTRUE(all.equal(clean(maSAE), clean(forestinventory)))) {
    message <- c(
      "Differing results from maSAE and forestinventory: ",
      message
    )
    warning(message)
    return(FALSE)
  }
  return(TRUE)
}

data(grisons, package = "forestinventory")

formula.s0 <- tvol ~ mean # reduced model:
formula.s1 <- tvol ~ mean + stddev + max + q75 # full model


truemeans.G <- data.frame(
  Intercept = rep(1, 4),
  mean = c(12.85, 12.21, 9.33, 10.45)
)
rownames(truemeans.G) <- c("A", "B", "C", "D")

s12_3p <- grisons[grisons[["phase_id_3p"]] %in% c(1, 2), ]
s12_3p$s2 <- s12_3p$phase_id_3p == 2
s12_3p$phase_id_2p <- NULL
s12_3p$phase_id_3p <- NULL
tm <- truemeans.G
tm[["smallarea"]] <- row.names(tm)
tm[["Intercept"]] <- NULL


test_partially_exhaustive_auxiliary_information <- function() {
  extsynth_3p <- threephase(formula.s0, formula.s1,
    data = grisons,
    phase_id = list(
      phase.col = "phase_id_3p",
      s1.id = 1, terrgrid.id = 2
    ),
    small_area = list(
      sa.col = "smallarea", areas = c("A", "B", "C", "D"),
      unbiased = TRUE
    ),
    exhaustive = truemeans.G,
    boundary_weights = "boundary_weights"
  )

  ## -----------------------------------------------------------------------------
  maSAE <- predict(saObj(
    data = s12_3p,
    f = update(formula.s1, ~ . | smallarea),
    auxiliaryWeights = "boundary_weights",
    s2 = "s2", smallAreaMeans = tm
  ))
  RUnit::checkEquals(clean(maSAE), clean(extsynth_3p))
}

message("Tests for the clustered three-phase design")
if (interactive()) {
  pkgload::load_all(".")
  source(file.path(
    devtools::as.package(".")["path"], "inst", "runit_tests",
    "setup.R"
  ))
}
data(list = paste0("s", 0:2), package = "maSAE")

s0$x1 <- s0$x3 <- NULL
s012 <- bind_data(s1, s2, s0)
# adapt data for forestinventory
s012$g[is.na(s012$g)] <- "a"
s012$phase <- s012$phase1 + s012$phase2

formula.s1 <- y ~ x1 + x2 + x3
formula.s0 <- y ~ x2
tm <- aggregate(cbind(x1, x2, x3) ~ g, data = s012, "mean")
tm_partially <- tm[, -c(2, 4)]
truemeans.G <- cbind("Intercept" = 1, tm[TRUE, paste0("x", 1:3)])
truemeans.G_partially <- truemeans.G[, -c(2, 4)]
rownames(truemeans.G) <- tm$g
fitp <- forestinventory::threephase


# when we use full means, we go back to twophase.
# maSAE does so automatically, forestinventory throws an error, so we need to
# adapt the data set for forestinventory.
three_as_two <- s012
three_as_two$phase[three_as_two$phase == 0] <- 1


test_nonex_noweights <- function() {
  message("Tests for non-exhaustive auxiliary data without weights")

  maSAE <- predict(suppressMessages(saObj(
    data = s012, f = update(formula.s1, ~ . | g),
    s1 = "phase1", s2 = "phase2", cluster = "clustid"
  )),
  use_lm = FALSE
  )
  ##### % extended pseudo synthetic estimator
  if (interactive()) {
    ## This is how I got fixed estimations from package
    ## forestinventory as reference.
    fi <- fitp(formula.s0, formula.s1,
      data = s012,
      phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
      cluster = "clustid",
      small_area = list(
        sa.col = "g", areas = c("a", "b"),
        unbiased = TRUE
      )
    )[["estimation"]]
    dump_file <- tempfile()
    dump("fi", file = dump_file)
    cat(sep = "\n", readLines(dump_file))
  }
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      385.031841932114,
      404.967740283593
    ), ext_variance = c(137.417365329949, 451.0187603266), g_variance = c(144.439678550074, 493.600475190784), n0 = c(
      3446L,
      3446L
    ), n1 = c(344L, 344L), n2 = c(68L, 68L), n0G = c(
      2584L,
      862L
    ), n1G = c(242L, 102L), n2G = c(47L, 21L), r.squared_reduced = c(
      0.530634582506201,
      0.530634582506201
    ), r.squared_full = c(0.886960953238245, 0.886960953238245)), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(fi), clean(maSAE))

  ##### %  pseudo synthetic estimator
  if (interactive()) {
    ## This is how I got fixed estimations from package
    ## forestinventory as reference.
    fi <- fitp(formula.s0, formula.s1,
      data = s012,
      phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
      cluster = "clustid",
      small_area = list(
        sa.col = "g", areas = c("a", "b"),
        unbiased = FALSE
      )
    )[["estimation"]]
    dump_file <- tempfile()
    dump("fi", file = dump_file)
    cat(sep = "\n", readLines(dump_file))
  }
  # RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psynth"))
  ##### %  pseudo small area estimator
  if (interactive()) {
    ## This is how I got fixed estimations from package
    ## forestinventory as reference.
    fi <- fitp(formula.s0, formula.s1,
      data = s012,
      phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
      cluster = "clustid",
      psmall = TRUE,
      small_area = list(
        sa.col = "g", areas = c("a", "b"),
        unbiased = TRUE
      )
    )[["estimation"]]
    dump_file <- tempfile()
    dump("fi", file = dump_file)
    cat(sep = "\n", readLines(dump_file))
  }
  # RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psmall"))
}
if (interactive()) test_nonex_noweights()

no_test_nonex_weights <- function() {
  message("Tests for non-exhaustive auxiliary data with weights")
  maSAE <- predict(saObj(
    data = s012, f = update(formula.s1, ~ . | g),
    s2 = "s2", auxiliaryWeights = "boundary_weights"
  ),
  use_lm = FALSE
  )

  # % extended pseudo synthetic estimator
  RUnit::checkIdentical(clean(fi), clean(maSAE))
  # %  pseudo synthetic estimator
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psynth"))
  # %  pseudo small area estimator
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psmall"))
}

no_test_ex_weights <- function() {
  message("Tests for exhaustive auxiliary data with weights")
  old_options <- options(warn = 2)
  RUnit::checkException(predict(saObj(
    data = s012,
    f = update(formula.s1, ~ . | g),
    s2 = "s2",
    smallAreaMeans = tm,
    cluster = "clustid",
    auxiliaryWeights = "boundary_weights"
  ),
  use_lm = FALSE
  ))
  options(old_options)
  suppressWarnings(weighted <- predict(saObj(
    data = s012,
    f = update(formula.s1, ~ . | g),
    s2 = "phase2",
    smallAreaMeans = tm,
    cluster = "clustid",
    auxiliaryWeights = "weight"
  ),
  use_lm = FALSE
  ))
  not_weighted <- predict(saObj(
    data = s012,
    f = update(formula.s1, ~ . | g),
    s2 = "phase2",
    cluster = "clustid",
    smallAreaMeans = tm,
    auxiliaryWeights = NULL
  ),
  use_lm = FALSE
  )
  RUnit::checkIdentical(not_weighted, weighted)
}

test_ex_noweights <- function() {
  message("Tests for exhaustive auxiliary data without weights")

  maSAE <- predict(saObj(
    data = s012,
    f = update(formula.s1, ~ . | g),
    s2 = "phase2", cluster = "clustid",
    smallAreaMeans = tm
  ),
  use_lm = FALSE
  )

  ##### % extended pseudo synthetic estimator
  if (interactive()) {
    ## This is how I got fixed estimations from package
    ## forestinventory as reference.
    fi <- forestinventory::twophase(formula.s1,
      data = three_as_two,
      phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
      cluster = "clustid",
      exhaustive = truemeans.G,
      small_area = list(
        sa.col = "g", areas = c("a", "b"),
        unbiased = TRUE
      )
    )[["estimation"]]
    dump_file <- tempfile()
    dump("fi", file = dump_file)
    cat(sep = "\n", readLines(dump_file))
  }
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      388.925862054565,
      392.339527092439
    ), ext_variance = c(87.6471489397849, 288.170951914057), g_variance = c(94.0347482218164, 315.021024873811), n1 = c(
      Inf,
      Inf
    ), n2 = c(68, 68), n1G = c(Inf, Inf), n2G = c(47, 21), r.squared = c(
      0.886960953238245,
      0.886960953238245
    )), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(fi), clean(maSAE))
  ##### % pseudo synthetic estimator
  if (interactive()) {
    ## This is how I got fixed estimations from package
    ## forestinventory as reference.
    fi <- forestinventory::twophase(formula.s1,
      data = three_as_two,
      phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
      cluster = "clustid",
      exhaustive = truemeans.G,
      small_area = list(
        sa.col = "g", areas = c("a", "b"),
        unbiased = FALSE
      )
    )[["estimation"]]
    dump_file <- tempfile()
    dump("fi", file = dump_file)
    cat(sep = "\n", readLines(dump_file))
  }
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      391.100826482191,
      387.574968963254
    ), ext_variance = c(NA_real_, NA_real_), g_variance = c(
      66.8108732113946,
      80.0708154929257
    ), n1 = c(Inf, Inf), n2 = c(68, 68), n1G = c(
      Inf,
      Inf
    ), n2G = c(47, 21), r.squared = c(0.886694654412209, 0.886694654412209)), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psynth"))
  ##### % pseudo small area estimator
  if (interactive()) {
    ## This is how I got fixed estimations from package
    ## forestinventory as reference.
    fi <- forestinventory::twophase(formula.s1,
      data = three_as_two,
      phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
      cluster = "clustid",
      exhaustive = truemeans.G,
      psmall = TRUE,
      small_area = list(
        sa.col = "g", areas = c("a", "b"),
        unbiased = TRUE
      )
    )[["estimation"]]
    dump_file <- tempfile()
    dump("fi", file = dump_file)
    cat(sep = "\n", readLines(dump_file))
  }
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      389.072092128464,
      392.286868107391
    ), ext_variance = c(87.4066709920268, 288.925535683403), g_variance = c(154.217544203421, 368.996351176329), n1 = c(
      Inf,
      Inf
    ), n2 = c(68, 68), n1G = c(Inf, Inf), n2G = c(47, 21), r.squared = c(
      0.886694654412209,
      0.886694654412209
    )), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psmall"))
}

no_test_partially <- function() {
  # see runit-uc_2p.R function test_partially() for an explanation.

  # here, I set tm_partially to something different than the sample mean of
  # the s0 data, else it yields exaxctly the same results as twophase, which
  # is true but confusing.
  tm_partially <- tm[, -c(2, 3)]

  not_weighted <- predict(suppressMessages(saObj(
    data = s012, f = update(formula.s1, ~ . | g),
    s1 = "phase1", s2 = "phase2",
    smallAreaMeans = tm_partially,
    cluster = "clustid"
  )),
  use_lm = FALSE
  )

  if (interactive()) {
    dump_file <- tempfile()
    expectation <- clean(not_weighted)
    dump("expectation", file = dump_file)
    cat(sep = "\n", readLines(dump_file))
  }
  expectation <-
    structure(c("a", "b", "388.9259", "392.3395", "117.2678", "330.1792"), .Dim = 2:3, .Dimnames = list(c("1", "2"), NULL))

  RUnit::checkIdentical(clean(not_weighted, FALSE), expectation)
  if (FALSE) {
    weighted <- predict(saObj(
      data = s012, f = update(formula.s1, ~ . | g),
      auxiliaryWeights = "weights",
      s2 = "phase2", smallAreaMeans = tm_partially, cluster = "clustid"
    ),
    use_lm = FALSE
    )
    RUnit::checkIdentical(clean(not_weighted, FALSE), expectation)
    get_figs <- function(x) {
      return(apply(clean(x, FALSE)[, -1], 2, as.numeric))
    }
    RUnit::checkTrue(!isTRUE(all.equal(get_figs(not_weighted), get_figs(weighted))))
  }
}

message("Tests for the clustered two-phase design")
if (interactive()) {
  pkgload::load_all(".")
  source(file.path(
    devtools::as.package(".")["path"], "inst", "runit_tests",
    "setup.R"
  ))
}
data(list = paste0("s", 0:2), package = "maSAE")

s12 <- bind_data(s1, s2)
# adapt data for forestinventory
s12$g[is.na(s12$g)] <- "a"
s12$phase <- s12$phase1 + s12$phase2

# fake some weights
sum_rel_dev <- rowSums((s12[, c(paste0("x", 1:3))] -
  colMeans(s12[, c(paste0("x", 1:3))])) / colMeans(s12[, c(paste0("x", 1:3))]))
set.seed(56467)
s12$weight <- rnorm(nrow(s12), mean = 3 + sum_rel_dev, sd = 0.01)
s12$weight[s12$weight < 0] <- 0
s12$weight[s12$weight > 1] <- 1
formula.s1 <- y ~ x1 + x2 + x3
tm <- aggregate(cbind(x1, x2, x3) ~ g, data = s12, "mean")
tm_partially <- tm[, -c(2, 4)]
truemeans.G <- cbind("Intercept" = 1, tm[TRUE, paste0("x", 1:3)])
rownames(truemeans.G) <- tm$g



test_nonex_noweights <- function() {
  message("Tests for non-exhaustive auxiliary data without weights")

  maSAE <- predict(suppressMessages(saObj(
    data = s12, f = update(formula.s1, ~ . | g),
    s2 = "phase2", cluster = "clustid"
  )),
  use_lm = FALSE
  )
  ##### % extended pseudo synthetic estimator
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      388.925862054566,
      392.339527092439
    ), ext_variance = c(87.6471489397849, 288.170951914057), g_variance = c(254.329302626316, 807.322394330049), n1 = c(
      344,
      344
    ), n2 = c(68, 68), n1G = c(242, 102), n2G = c(47, 21), r.squared = c(
      0.886960953238245,
      0.886960953238245
    )), row.names = c(NA, -2L), class = "data.frame")

  RUnit::checkIdentical(clean(fi), clean(maSAE))

  ##### %  pseudo synthetic estimator
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      391.100826482191,
      387.574968963254
    ), ext_variance = c(NA_real_, NA_real_), g_variance = c(
      228.097762567531,
      575.59806719354
    ), n1 = c(344, 344), n2 = c(68, 68), n1G = c(
      242,
      102
    ), n2G = c(47, 21), r.squared = c(0.886694654412209, 0.886694654412209)), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psynth"))
  ##### %  pseudo small area estimator
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      389.072092128464,
      392.286868107391
    ), ext_variance = c(87.4395646223382, 289.159523123657), g_variance = c(315.504433559558, 864.523602876943), n1 = c(
      344,
      344
    ), n2 = c(68, 68), n1G = c(242, 102), n2G = c(47, 21), r.squared = c(
      0.886694654412209,
      0.886694654412209
    )), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psmall"))
}
if (interactive()) test_nonex_noweights()

no_test_nonex_weights <- function() {
  message("Tests for non-exhaustive auxiliary data with weights")
  maSAE <- predict(saObj(
    data = s12, f = update(formula.s1, ~ . | smallarea),
    s2 = "s2", auxiliaryWeights = "boundary_weights"
  ),
  use_lm = FALSE
  )

  # % extended pseudo synthetic estimator
  RUnit::checkIdentical(clean(fi), clean(maSAE))
  # %  pseudo synthetic estimator
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psynth"))
  # %  pseudo small area estimator
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psmall"))
}

test_ex_weights <- function() {
  message("Tests for exhaustive auxiliary data with weights")
  old_options <- options(warn = 2)
  RUnit::checkException(predict(saObj(
    data = s12,
    f = update(formula.s1, ~ . | g),
    s2 = "s2",
    smallAreaMeans = tm,
    cluster = "clustid",
    auxiliaryWeights = "boundary_weights"
  ),
  use_lm = FALSE
  ))
  options(old_options)
  suppressWarnings(weighted <- predict(saObj(
    data = s12,
    f = update(formula.s1, ~ . | g),
    s2 = "phase2",
    smallAreaMeans = tm,
    cluster = "clustid",
    auxiliaryWeights = "weight"
  ),
  use_lm = FALSE
  ))
  not_weighted <- predict(saObj(
    data = s12,
    f = update(formula.s1, ~ . | g),
    s2 = "phase2",
    cluster = "clustid",
    smallAreaMeans = tm,
    auxiliaryWeights = NULL
  ),
  use_lm = FALSE
  )
  RUnit::checkTrue(!identical(not_weighted, weighted))
}

test_ex_noweights <- function() {
  message("Tests for exhaustive auxiliary data without weights")

  maSAE <- predict(saObj(
    data = s12,
    f = update(formula.s1, ~ . | g),
    s2 = "phase2", cluster = "clustid",
    smallAreaMeans = tm
  ),
  use_lm = FALSE
  )

  ##### % extended pseudo synthetic estimator
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      388.925862054565,
      392.339527092439
    ), ext_variance = c(87.6471489397849, 288.170951914057), g_variance = c(94.0347482218164, 315.021024873811), n1 = c(
      Inf,
      Inf
    ), n2 = c(68, 68), n1G = c(Inf, Inf), n2G = c(47, 21), r.squared = c(
      0.886960953238245,
      0.886960953238245
    )), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(fi), clean(maSAE))
  ##### % pseudo synthetic estimator
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      391.100826482191,
      387.574968963254
    ), ext_variance = c(NA_real_, NA_real_), g_variance = c(
      66.8108732113946,
      80.0708154929257
    ), n1 = c(Inf, Inf), n2 = c(68, 68), n1G = c(
      Inf,
      Inf
    ), n2G = c(47, 21), r.squared = c(0.886694654412209, 0.886694654412209)), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psynth"))
  ##### % pseudo small area estimator
  fi <-
    structure(list(area = c("a", "b"), estimate = c(
      389.072092128464,
      392.286868107391
    ), ext_variance = c(87.4066709920268, 288.925535683403), g_variance = c(154.217544203421, 368.996351176329), n1 = c(
      Inf,
      Inf
    ), n2 = c(68, 68), n1G = c(Inf, Inf), n2G = c(47, 21), r.squared = c(
      0.886694654412209,
      0.886694654412209
    )), row.names = c(NA, -2L), class = "data.frame")

  RUnit::checkIdentical(clean(fi), clean(maSAE, which = "psmall"))
}

test_partially <- function() {
  # see runit-uc_20.R function test_partially() for an explanation
  not_weighted <- predict(saObj(
    data = s12, f = update(formula.s1, ~ . | g),
    s2 = "phase2", smallAreaMeans = tm_partially, cluster = "clustid"
  ),
  use_lm = FALSE
  )
  expectation <-
    structure(list(small_area = structure(1:2, .Label = c("a", "b"), class = "factor"), prediction = c(388.925862054566, 392.339527092439), variance = c(136.100887183427, 459.497317094639), psynth = c(
      391.100826482191,
      387.574968963254
    ), var_psynth = c(103.174388911079, 109.132901007312), psmall = c(389.072092128464, 392.286868107392), var_psmall = c(
      190.581059903106,
      398.058436690715
    )), row.names = c(NA, -2L), class = "data.frame")
  RUnit::checkIdentical(clean(not_weighted, FALSE), clean(expectation, FALSE))
  if (FALSE) {
    weighted <- predict(saObj(
      data = s12, f = update(formula.s1, ~ . | g),
      s2 = "phase2", smallAreaMeans = tm_partially, cluster = "clustid",
      auxiliaryWeights = "weight"
    ),
    use_lm = FALSE
    )
    RUnit::checkIdentical(clean(not_weighted, FALSE), expectation)
    get_figs <- function(x) {
      return(apply(clean(x, FALSE)[, -1], 2, as.numeric))
    }
    RUnit::checkTrue(!isTRUE(all.equal(get_figs(not_weighted), get_figs(weighted))))
  }
}

if (FALSE) {
  ## This is the mimick I used to get fixed estimations from package
  ## forestinventory as reference.
  truemeans.G_partially <- truemeans.G[, -c(2, 4)]
  fi <- forestinventory::twophase(formula.s1,
    data = s12,
    phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
    psmall = TRUE,
    exhaustive = truemeans.G_partially,
    small_area = list(
      sa.col = "g", areas = c("a", "b"),
      unbiased = TRUE
    )
  )[["estimation"]]
  dump("fi")
}

## -----------------------------------------------------------------------------
library("forestinventory")
library("maSAE")


## -----------------------------------------------------------------------------
clean <- function(x, which = NULL) {
    if (identical(FALSE, which)) {
        res <- as.matrix(unname(x[TRUE, TRUE]))
    } else {
        if (is.null(which)) {
            if (all(c( "small_area", "prediction", "variance") %in% names(x))) {
                res <- as.matrix(unname(x[TRUE, 1:3]))
            } else {
                res <- as.matrix(unname(x[["estimation"]][TRUE, c("area", "estimate", "g_variance")]))
            }
        } else {
            res <- as.matrix(unname(x[TRUE, c(1, grep(which, names(x)))]))
        }
    }
    return(res)
} 

compare <- function(maSAE, forestinventory, message = NULL) {
    if(! isTRUE(all.equal(clean(maSAE), clean(forestinventory), 
                          check.attributes = FALSE))) {
        message <- c("Differing results from maSAE and forestinventory: ", 
                     message)
        warning(message)
        return(FALSE)
    } 
    return(TRUE)
}


## -----------------------------------------------------------------------------
data(grisons, package = "forestinventory")


## -----------------------------------------------------------------------------
formula.s0 <- tvol ~ mean # reduced model:
formula.s1 <- tvol ~ mean + stddev + max + q75 # full model
formula.clust.s0 <- basal ~ stade
formula.clust.s1 <- basal ~ stade + couver + melange



## -----------------------------------------------------------------------------
truemeans.G <- data.frame(Intercept = rep(1, 4),
                          mean = c(12.85, 12.21, 9.33, 10.45),
                          stddev = c(9.31, 9.47, 7.90, 8.36),
                          max = c(34.92, 35.36, 28.81, 30.22),
                          q75 = c(19.77, 19.16, 15.40, 16.91))
rownames(truemeans.G) <- c("A", "B", "C", "D")

# data adjustments
s1 <- grisons[grisons[["phase_id_2p"]] == 1, ]
s2 <- grisons[grisons[["phase_id_2p"]] == 2, ]
s12 <- rbind(s1, s2)
s12$s1 <- s12$phase_id_2p %in% c(1, 2)
s12$s2 <- s12$phase_id_2p == 2

tm <- truemeans.G
tm[["smallarea"]] <- row.names(tm)
tm[["Intercept"]] <- NULL

truemeans.G.partially <- truemeans.G[, -which(names(truemeans.G) %in% c("stddev", "mean"))]
tm.partially <- tm[, -which(names(tm) %in% c("stddev", "mean"))]



## -----------------------------------------------------------------------------
summary(twophase(formula = formula.s1, 
                 data = grisons,
                 phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                 small_area = list(sa.col = "smallarea", 
                                   areas = c("A", "B","C", "D"),
                                   unbiased = TRUE),
                 boundary_weights = "boundary_weights"
                 ))


## -----------------------------------------------------------------------------
maSAE <- predict(saObj(data = s12,
                       f = update(formula.s1, ~ . | smallarea),
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2')
)

forestinventory <- twophase(formula = formula.s1, 
                            data = grisons,
                            phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                            small_area = list(sa.col = "smallarea", 
                                              areas = c("A", "B","C", "D"),
                                              unbiased = TRUE),
                            boundary_weights = "boundary_weights"
                            )


## -----------------------------------------------------------------------------
compare(maSAE, forestinventory, "two-phase, ext. pseudo sae")


## -----------------------------------------------------------------------------
wrap_two <- function(...) {
    dots <- list(...)
    dots$small_area$unbiased <- TRUE
    ex <- do.call(twophase, dots)$estimation
    dots$psmall <- TRUE
    small <- do.call(twophase, dots)$estimation
    dots$psmall <- FALSE
    dots$small_area$unbiased <- FALSE
    synth <- do.call(twophase, dots)$estimation
    cbind(ex[TRUE, c("estimate", "g_variance")], 
          synth[TRUE, c("estimate", "g_variance")], 
          small[TRUE, c("estimate", "g_variance")])

}
mbmb <- microbenchmark::microbenchmark
mb <- mbmb(
           forestinventory = wrap_two(formula = formula.s1, 
                                    data = grisons,
                                    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                                    small_area = list(sa.col = "smallarea", 
                                                      areas = c("A", "B","C", "D"),
                                                      unbiased = TRUE)
                                    ), 
           maSAE = predict(saObj(data = s12, 
                                 f = update(formula.s1, ~ . | smallarea),
                                 s2 = 's2'
                                 ))[, -1],
           check = "equivalent"
           )


## -----------------------------------------------------------------------------
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)



## -----------------------------------------------------------------------------
forestinventory <- twophase(formula = formula.s1, 
                            data = grisons,
                            phase_id = list(phase.col = "phase_id_2p", 
                                            terrgrid.id = 2),
                            small_area = list(sa.col ="smallarea", 
                                              areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE),
                            exhaustive = truemeans.G)
summary(forestinventory)


## -----------------------------------------------------------------------------
maSAE <- predict(saObj(data = s12, 
                       f = update(formula.s1, ~ . | smallarea),
                       s2 = 's2',
                       smallAreaMeans = tm))
compare(maSAE, forestinventory, "two-phase, ext. sae")


## -----------------------------------------------------------------------------
mb <- mbmb(
           forestinventory = wrap_two(formula = formula.s1, 
                                            data = grisons,
                                            phase_id = list(phase.col = "phase_id_2p", 
                                                            terrgrid.id = 2),
                                            small_area = list(sa.col ="smallarea", 
                                                              areas = c("A", "B", "C", "D"),
                                                              unbiased = TRUE),
                                            exhaustive = truemeans.G),
           maSAE = predict(saObj(data = s12, 
                                       f = update(formula.s1, ~ . | smallarea),
                                       s2 = 's2',
                                       smallAreaMeans = tm))[, -1],

           check = "equivalent")
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)


## -----------------------------------------------------------------------------
truemeans.G <- data.frame(Intercept = rep(1, 4),
                          mean = c(12.85, 12.21, 9.33, 10.45))
rownames(truemeans.G) <- c("A", "B", "C", "D")

## data adjustments
s12_3p <- grisons[grisons[["phase_id_3p"]] %in% c(1,2), ]
s0 <- grisons[grisons[["phase_id_3p"]] ==0 , ]
s12_3p$s1 <- s12_3p$phase_id_3p %in% c(1, 2)
s12_3p$s2 <- s12_3p$phase_id_3p == 2
s0$s1 <- s0$s2 <- FALSE
predictors_s0 <- all.vars(formula.s0)[-1]
predictors_s1 <- all.vars(formula.s1)[-1]
eval(parse(text=(paste0("s0$",
                        setdiff(predictors_s1, predictors_s0),
                        " <- NA"))))
s012 <- rbind(s0, s12_3p)
tm <- truemeans.G
tm[["smallarea"]] <- row.names(tm)
tm[["Intercept"]] <- NULL



## -----------------------------------------------------------------------------
summary(threephase(formula.s0,
                   formula.s1,
                   data = grisons,
                   phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                   small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                   unbiased = TRUE),
                   boundary_weights = "boundary_weights"
                   ))


## -----------------------------------------------------------------------------
forestinventory <- threephase(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE),
                              boundary_weights = "boundary_weights"
                              )

maSAE <- predict(saObj(data = s012, 
                       f = update(formula.s1, ~ . | smallarea),
                       s1 = 's1',
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2'))



## -----------------------------------------------------------------------------
compare(maSAE, forestinventory, "three-phase, ext. pseudo sae")


## -----------------------------------------------------------------------------
wrap_three <- function(...) {
    dots <- list(...)
    dots$small_area$unbiased <- TRUE
    ex <- do.call(threephase, dots)$estimation
    dots$psmall <- TRUE
    small <- do.call(threephase, dots)$estimation
    dots$psmall <- FALSE
    dots$small_area$unbiased <- FALSE
    synth <- do.call(threephase, dots)$estimation
    cbind(ex[TRUE, c("estimate", "g_variance")], 
          synth[TRUE, c("estimate", "g_variance")], 
          small[TRUE, c("estimate", "g_variance")])

}
mb <- mbmb(
           forestinventory = wrap_three(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE)
                              ),
           maSAE = predict(suppressMessages(saObj(data = s012, 
                       f = update(formula.s1, ~ . | smallarea),
                       s1 = 's1',
                       s2 = 's2')))[, -1],

           check = "equivalent")
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)


## -----------------------------------------------------------------------------
try(twophase(formula = formula.s1, 
             data = grisons,
             phase_id = list(phase.col = "phase_id_2p", 
                             terrgrid.id = 2),
             small_area = list(sa.col ="smallarea", 
                               areas = c("A", "B", "C", "D"),
                               unbiased = TRUE),
             exhaustive = truemeans.G.partially))
predict(saObj(data = s12, 
              f = update(formula.s1, ~ . | smallarea),
              s2 = 's2',
              smallAreaMeans = tm.partially))



## -----------------------------------------------------------------------------

summary(forestinventory <- threephase(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                                unbiased = TRUE),
                              exhaustive = truemeans.G))



try(predict(saObj(data = s012, 
              f = update(formula.s1, ~ . | smallarea),
              s2 = 's2',
              s1 = 's1',
              smallAreaMeans = tm)))



## -----------------------------------------------------------------------------
extsynth_3p <- threephase(formula.s0, formula.s1, data = grisons,
                          phase_id = list(phase.col = "phase_id_3p",
                                          s1.id = 1, terrgrid.id = 2),
                          small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                            unbiased = TRUE),
                          exhaustive = truemeans.G,
                          boundary_weights = "boundary_weights"
                          )
extsynth_3p$estimation


## -----------------------------------------------------------------------------
s12_3p$s1 <- NULL
s12_3p$phase_id_2p <- NULL
s12_3p$phase_id_3p <- NULL
maSAE <- predict(saObj(data = s12_3p, 
                       f = update(formula.s1, ~ . | smallarea),
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2', smallAreaMeans = tm)
)
compare(maSAE, extsynth_3p, "three-phase, ext. sae")



## -----------------------------------------------------------------------------
mb <- mbmb(
           forestinventory = wrap_three(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                                unbiased = TRUE),
                              exhaustive = truemeans.G),
           maSAE = predict(suppressMessages(saObj(data = s12_3p, 
                       f = update(formula.s1, ~ . | smallarea),
                       s2 = 's2', smallAreaMeans = tm)))[, -1],
           check = "equivalent")
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)



## -----------------------------------------------------------------------------

suppressWarnings(rm("s1" ,"s2", "s12"))
data("s1", "s2", package = "maSAE")
s12 <- bind_data(s1, s2)
# adapt for forestinventory
s12[["g"]][is.na(s12[["g"]])] <- "a"
s12[["phase"]]  <-  s12[["phase1"]] + s12[["phase2"]]
maSAE <- predict(suppressMessages(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", cluster = "clustid")))
extpsynth.clust <- twophase(y ~x1 + x2 + x3,
         data = s12,
         cluster = "clustid",
         phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
         small_area = list(sa.col = "g", areas = c("a", "b"),
                           unbiased = TRUE))
compare(maSAE, extpsynth.clust, "three-phase, ext. sae")
mb <- mbmb(
           forestinventory = clean(twophase(y ~x1 + x2 + x3,
         data = s12,
         cluster = "clustid",
         phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
         small_area = list(sa.col = "g", areas = c("a", "b"),
                           unbiased = TRUE))),
           maSAE = clean(predict(suppressMessages(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", cluster = "clustid")))),

           check = "equivalent")
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)



## -----------------------------------------------------------------------------
data("zberg", package = "forestinventory")
forestinventory <- forestinventory::twophase(
  formula = basal ~ stade + couver + melange, data = zberg,
  phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
  cluster = "cluster",
  small_area = list(
    sa.col = "ismallold", areas = c("1"),
    unbiased = TRUE
  )
)
s1 <- zberg[zberg[["phase_id_2p"]] == 1, ]
s2 <- zberg[zberg[["phase_id_2p"]] == 2, ]
s12 <- rbind(s1, s2)
s12[["s1"]] <- s12[["phase_id_2p"]] %in% c(1, 2)
s12[["s2"]] <- s12[["phase_id_2p"]] == 2
object <- maSAE::saObj(
  data = s12,
  f = basal ~ stade + couver + melange | ismallold,
  s2 = "s2",
  cluster = "cluster"
)
maSAE <- maSAE::predict(object)
compare(maSAE[2,], forestinventory, "clustered, ext. sae")


## -----------------------------------------------------------------------------
forestinventory <- forestinventory::twophase(
  formula = basal ~ stade + couver + melange, data = zberg,
  phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
  small_area = list(
    sa.col = "ismallold", areas = c("1"),
    unbiased = TRUE
  )
)
object <- maSAE::saObj(
  data = s12,
  f = basal ~ stade + couver + melange | ismallold,
  s2 = "s2",
)
maSAE <- maSAE::predict(object)
compare(maSAE[2,], forestinventory, "clustered, ext. sae")

library("maSAE")
message("## ## ## unclustered")
message("## ## non-exhaustive")
message("## load s2 data")
data("s2")
str(s2)
message("## load s1 data")
data("s1")
str(s1)
message("## add sample indicators to s2")
s2$s1 <- s2$s2 <- TRUE
message("## add sample indicators to s1")
s1$s1 <- TRUE
s1$s2 <- FALSE
message("## prepare s1 data")
eval(parse(text = (paste("s1$", setdiff(names(s2), names(s1)), " <- NA", sep = ""))))
message("## union s1 and s2 data")
s12 <- rbind(s1, s2)
message("## create object")
saeO <- saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "s2")
message("## small area estimation")
predict(saeO)


message("## ## three-phase")
message("## load s0 data")
data("s0")
message("## s0 has all 3 potential predictors, we keep one only")
s0$x1 <- s0$x3 <- NULL
message("## add sample indicators to s1")
s0$s1 <- s0$s2 <- FALSE
message("## prepare s1 data")
eval(parse(text = (paste("s0$", setdiff(names(s12), names(s0)), " <- NA", sep = ""))))
message("## union s12 and s0 data")
s012 <- rbind(s0, s12)
message("## create object")
saeO <- saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "s1", s2 = "s2")
message("## small area estimation")
predict(saeO)

message("## ## partially exhaustive")
tm <- as.data.frame(tapply(s012$x2, s012$g, mean))
tm$g <- row.names(tm)
names(tm) <- c("x2", "g")
predict(saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "s2", smallAreaMeans = tm))

message("## ## exhaustive")
message("## true Means as sample means from s12")
preds <- paste("x", 1:3, sep = "")
tm <- as.data.frame(
  rbind(
    colMeans(subset(s12, g == "a")[, preds]),
    colMeans(subset(s12, g == "b")[, preds])
  )
)
tm$g <- c("a", "b")
predict(saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "s2", smallAreaMeans = tm))

message("## ## ## clustered")
message("## ## non-exhaustive")
message("## load s2 data")
data("s2")
str(s2)
message("## load s1 data")
data("s1")
str(s1)
message("## add sample indicators to s2")
s2$s1 <- s2$s2 <- TRUE
message("## add sample indicators to s1")
s1$s1 <- TRUE
s1$s2 <- FALSE
message("## prepare s1 data")
eval(parse(text = (paste("s1$", setdiff(names(s2), names(s1)), " <- NA", sep = ""))))
message("## union s1 and s2 data")
s12 <- rbind(s1, s2)
message("## create object")
saeO <- saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "s2", cluster = "clustid")
message("## small area estimation")
predict(saeO)


message("## ## three-phase")
message("## load s0 data")
data("s0")
message("## s0 has all 3 potential predictors, we keep one only")
s0$x1 <- s0$x3 <- NULL
message("## add sample indicators to s1")
s0$s1 <- s0$s2 <- FALSE
message("## prepare s1 data")
eval(parse(text = (paste("s0$", setdiff(names(s12), names(s0)), " <- NA", sep = ""))))
message("## union s12 and s0 data")
s012 <- rbind(s0, s12)
message("## create object")
saeO <- saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "s1", s2 = "s2", cluster = "clustid")
message("## small area estimation")
predict(saeO)

message("## ## partially exhaustive")
tm <- as.data.frame(tapply(s012$x2, s012$g, mean))
tm$g <- row.names(tm)
names(tm) <- c("x2", "g")
predict(saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "s2", cluster = "clustid", smallAreaMeans = tm))

message("## ## exhaustive")
message("## true Means as sample means from s12")
preds <- paste("x", 1:3, sep = "")
tm <- as.data.frame(
  rbind(
    colMeans(subset(s12, g == "a")[, preds]),
    colMeans(subset(s12, g == "b")[, preds])
  )
)
tm$g <- c("a", "b")
predict(saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "s2", cluster = "clustid", smallAreaMeans = tm))

library("maSAE")
message("## load data")
data("s2")
message("## create object")
saeO <- saObj(data = s2, f = y ~ NULL | g)
message("## design-based estimation for all small areas given by g")
predict(saeO)
message("## again, assuming the data are clustered:")
saeO <- saObj(data = s2, f = y ~ NULL | g, cluster = "clustid")
message("## as expected, the variances disregarding the clusters were deflated:")
predict(saeO)

message("Ensure 1.0.0 and 2.0.0 give same predictions and variances")
if (interactive()) {
  pkgload::load_all(".")
  source(file.path(
    devtools::as.package(".")["path"], "inst", "runit_tests",
    "setup.R"
  ))
}

suppressWarnings(rm(s1, s2, s0))
data("s1", "s2", "s0", package = "maSAE")
s0$x1 <- s0$x3 <- NULL
s12 <- bind_data(s1, s2)
s012 <- bind_data(s1, s2, s0)
tm <- data.frame(x1 = c(150, 200), x2 = c(23, 23), x3 = c(7, 7.5), g = c("a", "b"))
tm_p <- data.frame(x2 = c(23, 23), g = c("a", "b"))

test_lm_unclustered <- function() {

  # % two-phase
  ## % partially exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p)
  out <- maSAE::predict(object)
  out_v1 <- maSAE::predict(object, version = "1.0.0")
  RUnit::checkEquals(out[1:3], out_v1, check.attributes = FALSE)

  ## % exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm)
  out <- maSAE::predict(object)
  out_v1 <- maSAE::predict(object, version = "1.0.0")
  RUnit::checkEquals(out[1:3], out_v1, check.attributes = FALSE)

  ## % non-exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2")
  out <- maSAE::predict(object)
  out_v1 <- maSAE::predict(object, version = "1.0.0")
  RUnit::checkEquals(out[1:3], out_v1, check.attributes = FALSE)

  # % three-phase
  object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2")
  out <- maSAE::predict(object)
  out_v1 <- maSAE::predict(object, version = "1.0.0")
  RUnit::checkEquals(out[1:3], out_v1, check.attributes = FALSE)
}

test_lm_clustered <- function() {
  # % two-phase
  ## % partially exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid")
  out <- maSAE::predict(object)
  out_v1 <- maSAE::predict(object, version = "1.0.0")
  RUnit::checkEquals(out[1:3], out_v1, check.attributes = FALSE)

  ## % exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid")
  out <- maSAE::predict(object)
  out_v1 <- maSAE::predict(object, version = "1.0.0")
  RUnit::checkEquals(out[1:3], out_v1, check.attributes = FALSE)

  ## % non-exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid")
  out <- maSAE::predict(object)
  out_v1 <- maSAE::predict(object, version = "1.0.0")
  RUnit::checkEquals(out[1:3], out_v1, check.attributes = FALSE)

  # % three-phase
  object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid")
  out <- maSAE::predict(object)
  out_v1 <- maSAE::predict(object, version = "1.0.0")
  RUnit::checkEquals(out[1:3], out_v1, check.attributes = FALSE)
}
if (interactive()) test_lm_clustered()

message("#% Tests against forestinventory")
if (interactive()) {
  pkgload::load_all(".")
  source(file.path(
    devtools::as.package(".")["path"], "inst", "runit_tests",
    "setup.R"
  ))
}

message("##% Tests for using zberg")
suppressWarnings(rm("s1", "s2", "s12"))
data("zberg", package = "forestinventory")
set.seed(1234)
zberg[["weights"]] <- sample(c(rep(1, 5), 0.2), nrow(zberg), replace = TRUE)
s1 <- zberg[zberg[["phase_id_2p"]] == 1, ]
s2 <- zberg[zberg[["phase_id_2p"]] == 2, ]
s12 <- rbind(s1, s2)
s12[["s1"]] <- s12[["phase_id_2p"]] %in% c(1, 2)
s12[["s2"]] <- s12[["phase_id_2p"]] == 2

test_unclustered_unweighted <- function() {
  fi <- forestinventory::twophase(
    formula = basal ~ stade + couver + melange, data = zberg,
    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
    small_area = list(
      sa.col = "ismallold", areas = c("1"),
      unbiased = TRUE
    )
  )$estimation
  object <- maSAE::saObj(
    data = s12,
    f = basal ~ stade + couver + melange | ismallold,
    s2 = "s2"
  )
  ma <- maSAE::predict(object)
  RUnit::checkEquals(ma[2, c(2, 3)], fi[c(2, 4)], check.attributes = FALSE)
}
if (interactive()) test_unclustered_unweighted()

test_unclustered_weighted <- function() {
  fi <- forestinventory::twophase(
    formula = basal ~ stade + couver + melange, data = zberg,
    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
    boundary_weights = "weights",
    small_area = list(
      sa.col = "ismallold", areas = c("1"),
      unbiased = TRUE
    )
  )$estimation
  object <- saObj(
    data = s12, f = basal ~ stade + couver + melange | ismallold,
    auxiliaryWeights = "weights",
    s2 = "s2"
  )
  ma <- maSAE::predict(object)
  RUnit::checkEquals(ma[2, c(2, 3)], fi[c(2, 4)], check.attributes = FALSE)
}
if (interactive()) test_unclustered_weighted()

### R code from vignette source 'An_Introduction_to_maSAE.Rnw'

###################################################
### code chunk number 1: An_Introduction_to_maSAE.Rnw:117-255
###################################################

fake_weights <- function(df) {
    df[["weights"]] <- 1
    df[["weights"]][df[["x2"]] == 0] <- 0.12
    return(df)
}
suppressWarnings(rm(s1, s2, s0))
data("s1", "s2", "s0", package = "maSAE")
s0$x1 <- s0$x3 <- NULL
s0 <- fake_weights(s0)
s1 <- fake_weights(s1)
s2 <- fake_weights(s2)
s12 <- maSAE::bind_data(s1, s2)
s012 <- maSAE::bind_data(s1, s2, s0)
tm <- data.frame(x1 = c(150, 200), x2 = c(23, 23), x3 = c(7, 7.5), g = c("a", "b"))
tm_p <- data.frame(x2 = c(23, 23), g = c("a", "b"))

#% unclustered

##% un-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm_p, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, 
                       s1 = "phase1", s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

#% clustered
##% un-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)


##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
(outlm <- maSAE::predict(object, use_lm = TRUE))
RUnit::checkEquals(out, outlm)

message("#% Tests against forestinventory")
if (interactive()) {
  pkgload::load_all(".")
  source(file.path(
    devtools::as.package(".")["path"], "inst", "runit_tests",
    "setup.R"
  ))
}

message("##% Tests for clustered sampling using s1, s2")
suppressWarnings(rm("s1", "s2", "s12"))
data("s1", "s2", package = "maSAE")
s12 <- bind_data(s1, s2)
# adapt for forestinventory
s12[["g"]][is.na(s12[["g"]])] <- "a"
s12[["phase"]] <- s12[["phase1"]] + s12[["phase2"]]
test_clustered_unweighted <- function() {
  ma <- maSAE::predict(saObj(
    data = s12, f = y ~ x1 + x2 + x3 | g,
    s2 = "phase2", cluster = "clustid"
  ))
  fi <- forestinventory::twophase(y ~ x1 + x2 + x3,
    data = s12,
    cluster = "clustid",
    phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
    small_area = list(
      sa.col = "g", areas = c("a", "b"),
      unbiased = TRUE
    )
  )$estimation
  RUnit::checkEquals(ma[c(2, 3)], fi[c(2, 4)], check.attributes = FALSE)
}
if (interactive()) test_clustered_unweighted()

message("Tests for using lm")
if (interactive()) {
  pkgload::load_all(".")
  source(file.path(
    devtools::as.package(".")["path"], "inst", "runit_tests",
    "setup.R"
  ))
}

fake_weights <- function(df) {
  df[["weights"]] <- 1
  df[["weights"]][df[["x2"]] == 0] <- 0.12
  return(df)
}
suppressWarnings(rm(s1, s2, s0))
data("s1", "s2", "s0", package = "maSAE")
s0$x1 <- s0$x3 <- NULL
s0 <- fake_weights(s0)
s1 <- fake_weights(s1)
s2 <- fake_weights(s2)
s12 <- bind_data(s1, s2)
s012 <- bind_data(s1, s2, s0)
tm <- data.frame(x1 = c(150, 200), x2 = c(23, 23), x3 = c(7, 7.5), g = c("a", "b"))
tm_p <- data.frame(x2 = c(23, 23), g = c("a", "b"))
test_lm_unclustered <- function() {

  # % unclustered

  ## % un-weighted
  ### % two-phase
  #### % partially exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p)
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  #### % exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm)
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  #### % non-exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2")
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  ### % three-phase
  object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2")
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  ## % weighted
  ### % two-phase
  #### % partially exhaustive
  object <- maSAE::saObj(
    data = s12, f = y ~ x1 + x2 + x3 | g,
    s2 = "phase2", smallAreaMeans = tm_p,
    auxiliaryWeights = "weights"
  )
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  #### % exhaustive
  object <- maSAE::saObj(
    data = s12, f = y ~ x1 + x2 + x3 | g,
    s2 = "phase2", smallAreaMeans = tm,
    auxiliaryWeights = "weights"
  )
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  #### % non-exhaustive
  object <- maSAE::saObj(
    data = s12, f = y ~ x1 + x2 + x3 | g,
    s2 = "phase2",
    auxiliaryWeights = "weights"
  )
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  ### % three-phase
  object <- maSAE::saObj(
    data = s012, f = y ~ x1 + x2 + x3 | g,
    s1 = "phase1", s2 = "phase2",
    auxiliaryWeights = "weights"
  )
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)
}
if (interactive()) test_lm_unclustered()


test_lm_clustered <- function() {
  # % clustered
  ## % un-weighted
  ### % two-phase
  #### % partially exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid")
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  #### % exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid")
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  #### % non-exhaustive
  object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid")
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  ### % three-phase
  object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid")
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)


  ## % weighted
  ### % two-phase
  #### % partially exhaustive
  object <- maSAE::saObj(
    data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid",
    auxiliaryWeights = "weights"
  )
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  #### % exhaustive
  object <- maSAE::saObj(
    data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid",
    auxiliaryWeights = "weights"
  )
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  #### % non-exhaustive
  object <- maSAE::saObj(
    data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid",
    auxiliaryWeights = "weights"
  )
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)

  ### % three-phase
  object <- maSAE::saObj(
    data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid",
    auxiliaryWeights = "weights"
  )
  out <- maSAE::predict(object, use_lm = FALSE)
  outlm <- maSAE::predict(object, use_lm = TRUE)
  RUnit::checkEquals(out, outlm)
}
if (interactive()) test_lm_clustered()

### R code from vignette source 'Estimators_in_Detail.Rnw'

###################################################
### code chunk number 1: Estimators_in_Detail.Rnw:129-267
###################################################

fake_weights <- function(df) {
    df[["weights"]] <- 1
    df[["weights"]][df[["x2"]] == 0] <- 0.12
    return(df)
}
suppressWarnings(rm(s1, s2, s0))
data("s1", "s2", "s0", package = "maSAE")
s0$x1 <- s0$x3 <- NULL
s0 <- fake_weights(s0)
s1 <- fake_weights(s1)
s2 <- fake_weights(s2)
s12 <- maSAE::bind_data(s1, s2)
s012 <- maSAE::bind_data(s1, s2, s0)
tm <- data.frame(x1 = c(150, 200), x2 = c(23, 23), x3 = c(7, 7.5), g = c("a", "b"))
tm_p <- data.frame(x2 = c(23, 23), g = c("a", "b"))

#% unclustered

##% un-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm_p, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, 
                       s1 = "phase1", s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

#% clustered
##% un-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)


##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
(outlm <- maSAE::predict(object, use_lm = TRUE))
RUnit::checkEquals(out, outlm)

---
title: "A Comparison of maSAE to forestinventory"
author: 
date: 2020-03-13, 13:16:56
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{A Comparison of maSAE to forestinventory}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# What is this about?

In 2016, Andreas Hill published package 
[forestinventory](https://CRAN.R-project.org/package=forestinventory).
We thought about merging the packages, but never actually got to it: 
`maSAE` is S4, `forestinventory` is S3, both of us are busy doing other stuff.
So I am trying to at least compare functionality of both packages.

```{r}
library("forestinventory")
library("maSAE")
```

# Setup

I need some helpers for checking and comparing results from 
`maSAE` and `forestinventory`:


``` {r}
clean <- function(x, which = NULL) {
    if (identical(FALSE, which)) {
        res <- as.matrix(unname(x[TRUE, TRUE]))
    } else {
        if (is.null(which)) {
            if (all(c( "small_area", "prediction", "variance") %in% names(x))) {
                res <- as.matrix(unname(x[TRUE, 1:3]))
            } else {
                res <- as.matrix(unname(x[["estimation"]][TRUE, c("area", "estimate", "g_variance")]))
            }
        } else {
            res <- as.matrix(unname(x[TRUE, c(1, grep(which, names(x)))]))
        }
    }
    return(res)
} 

compare <- function(maSAE, forestinventory, message = NULL) {
    if(! isTRUE(all.equal(clean(maSAE), clean(forestinventory), 
                          check.attributes = FALSE))) {
        message <- c("Differing results from maSAE and forestinventory: ", 
                     message)
        warning(message)
        return(FALSE)
    } 
    return(TRUE)
}
```

I use the grisons data set from `forestinventory`:

``` {r}
data(grisons, package = "forestinventory")
```

I define regression models for simple and cluster sampling:

``` {r}
formula.s0 <- tvol ~ mean # reduced model:
formula.s1 <- tvol ~ mean + stddev + max + q75 # full model
formula.clust.s0 <- basal ~ stade
formula.clust.s1 <- basal ~ stade + couver + melange

```

# Two-Phase 
Some data handling,
true means are taken from 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf). :

``` {r}
truemeans.G <- data.frame(Intercept = rep(1, 4),
                          mean = c(12.85, 12.21, 9.33, 10.45),
                          stddev = c(9.31, 9.47, 7.90, 8.36),
                          max = c(34.92, 35.36, 28.81, 30.22),
                          q75 = c(19.77, 19.16, 15.40, 16.91))
rownames(truemeans.G) <- c("A", "B", "C", "D")

# data adjustments
s1 <- grisons[grisons[["phase_id_2p"]] == 1, ]
s2 <- grisons[grisons[["phase_id_2p"]] == 2, ]
s12 <- rbind(s1, s2)
s12$s1 <- s12$phase_id_2p %in% c(1, 2)
s12$s2 <- s12$phase_id_2p == 2

tm <- truemeans.G
tm[["smallarea"]] <- row.names(tm)
tm[["Intercept"]] <- NULL

truemeans.G.partially <- truemeans.G[, -which(names(truemeans.G) %in% c("stddev", "mean"))]
tm.partially <- tm[, -which(names(tm) %in% c("stddev", "mean"))]

```

##  No Exhaustive Auxiliary Information

This is the estimation given on bottom of page 15 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf):
``` {r}
summary(twophase(formula = formula.s1, 
                 data = grisons,
                 phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                 small_area = list(sa.col = "smallarea", 
                                   areas = c("A", "B","C", "D"),
                                   unbiased = TRUE),
                 boundary_weights = "boundary_weights"
                 ))
```
Now I`m using both packages to make predictions:

``` {r}
maSAE <- predict(saObj(data = s12,
                       f = update(formula.s1, ~ . | smallarea),
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2')
)

forestinventory <- twophase(formula = formula.s1, 
                            data = grisons,
                            phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                            small_area = list(sa.col = "smallarea", 
                                              areas = c("A", "B","C", "D"),
                                              unbiased = TRUE),
                            boundary_weights = "boundary_weights"
                            )
```

Both packages deliver the same results:

``` {r}
compare(maSAE, forestinventory, "two-phase, ext. pseudo sae")
```

Now I benchmark them, calculating the small, synthetic and extended synthetic estimators:
``` {r}
wrap_two <- function(...) {
    dots <- list(...)
    dots$small_area$unbiased <- TRUE
    ex <- do.call(twophase, dots)$estimation
    dots$psmall <- TRUE
    small <- do.call(twophase, dots)$estimation
    dots$psmall <- FALSE
    dots$small_area$unbiased <- FALSE
    synth <- do.call(twophase, dots)$estimation
    cbind(ex[TRUE, c("estimate", "g_variance")], 
          synth[TRUE, c("estimate", "g_variance")], 
          small[TRUE, c("estimate", "g_variance")])

}
mbmb <- microbenchmark::microbenchmark
mb <- mbmb(
           forestinventory = wrap_two(formula = formula.s1, 
                                    data = grisons,
                                    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                                    small_area = list(sa.col = "smallarea", 
                                                      areas = c("A", "B","C", "D"),
                                                      unbiased = TRUE)
                                    ), 
           maSAE = predict(saObj(data = s12, 
                                 f = update(formula.s1, ~ . | smallarea),
                                 s2 = 's2'
                                 ))[, -1],
           check = "equivalent"
           )
```

`maSAE` seems a bit faster:

``` {r}
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)

```


##  Full Exhaustive Auxiliary Information
The estimation given on page 17 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf) is
 (there are no boundary weights here):

``` {r}
forestinventory <- twophase(formula = formula.s1, 
                            data = grisons,
                            phase_id = list(phase.col = "phase_id_2p", 
                                            terrgrid.id = 2),
                            small_area = list(sa.col ="smallarea", 
                                              areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE),
                            exhaustive = truemeans.G)
summary(forestinventory)
```

Again, predictions from both packages are identical:


``` {r}
maSAE <- predict(saObj(data = s12, 
                       f = update(formula.s1, ~ . | smallarea),
                       s2 = 's2',
                       smallAreaMeans = tm))
compare(maSAE, forestinventory, "two-phase, ext. sae")
```
The benchmarks again:

``` {r}
mb <- mbmb(
           forestinventory = wrap_two(formula = formula.s1, 
                                            data = grisons,
                                            phase_id = list(phase.col = "phase_id_2p", 
                                                            terrgrid.id = 2),
                                            small_area = list(sa.col ="smallarea", 
                                                              areas = c("A", "B", "C", "D"),
                                                              unbiased = TRUE),
                                            exhaustive = truemeans.G),
           maSAE = predict(saObj(data = s12, 
                                       f = update(formula.s1, ~ . | smallarea),
                                       s2 = 's2',
                                       smallAreaMeans = tm))[, -1],

           check = "equivalent")
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)
```


# Three-Phase
Some data handling,
true means are taken from 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf). :
``` {r}
truemeans.G <- data.frame(Intercept = rep(1, 4),
                          mean = c(12.85, 12.21, 9.33, 10.45))
rownames(truemeans.G) <- c("A", "B", "C", "D")

## data adjustments
s12_3p <- grisons[grisons[["phase_id_3p"]] %in% c(1,2), ]
s0 <- grisons[grisons[["phase_id_3p"]] ==0 , ]
s12_3p$s1 <- s12_3p$phase_id_3p %in% c(1, 2)
s12_3p$s2 <- s12_3p$phase_id_3p == 2
s0$s1 <- s0$s2 <- FALSE
predictors_s0 <- all.vars(formula.s0)[-1]
predictors_s1 <- all.vars(formula.s1)[-1]
eval(parse(text=(paste0("s0$",
                        setdiff(predictors_s1, predictors_s0),
                        " <- NA"))))
s012 <- rbind(s0, s12_3p)
tm <- truemeans.G
tm[["smallarea"]] <- row.names(tm)
tm[["Intercept"]] <- NULL

```

##  No Exhaustive Auxiliary Information

The estimation given on page 23 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf) is:

``` {r}
summary(threephase(formula.s0,
                   formula.s1,
                   data = grisons,
                   phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                   small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                   unbiased = TRUE),
                   boundary_weights = "boundary_weights"
                   ))
```
_Wait, the `ext_variance` differs, but that`s a problem with `forestinventory`..._

I make predictions omitting the boundary weights:

``` {r}
forestinventory <- threephase(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE),
                              boundary_weights = "boundary_weights"
                              )

maSAE <- predict(saObj(data = s012, 
                       f = update(formula.s1, ~ . | smallarea),
                       s1 = 's1',
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2'))

```

``` {r}
compare(maSAE, forestinventory, "three-phase, ext. pseudo sae")
```
The benchmarks again:

``` {r}
wrap_three <- function(...) {
    dots <- list(...)
    dots$small_area$unbiased <- TRUE
    ex <- do.call(threephase, dots)$estimation
    dots$psmall <- TRUE
    small <- do.call(threephase, dots)$estimation
    dots$psmall <- FALSE
    dots$small_area$unbiased <- FALSE
    synth <- do.call(threephase, dots)$estimation
    cbind(ex[TRUE, c("estimate", "g_variance")], 
          synth[TRUE, c("estimate", "g_variance")], 
          small[TRUE, c("estimate", "g_variance")])

}
mb <- mbmb(
           forestinventory = wrap_three(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE)
                              ),
           maSAE = predict(suppressMessages(saObj(data = s012, 
                       f = update(formula.s1, ~ . | smallarea),
                       s1 = 's1',
                       s2 = 's2')))[, -1],

           check = "equivalent")
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)
```

# Partially Exhaustive Auxiliary Information
Funny: `forestinventory` can`t deal with partially exhaustive auxiliary information for two-phase sampling:

``` {r}
try(twophase(formula = formula.s1, 
             data = grisons,
             phase_id = list(phase.col = "phase_id_2p", 
                             terrgrid.id = 2),
             small_area = list(sa.col ="smallarea", 
                               areas = c("A", "B", "C", "D"),
                               unbiased = TRUE),
             exhaustive = truemeans.G.partially))
predict(saObj(data = s12, 
              f = update(formula.s1, ~ . | smallarea),
              s2 = 's2',
              smallAreaMeans = tm.partially))

```
Whereas `maSAE` can`t deal with partially exhaustive auxiliary information for three-phase sampling:
``` {r}

summary(forestinventory <- threephase(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                                unbiased = TRUE),
                              exhaustive = truemeans.G))



try(predict(saObj(data = s012, 
              f = update(formula.s1, ~ . | smallarea),
              s2 = 's2',
              s1 = 's1',
              smallAreaMeans = tm)))

```
I do not see what three-phase partially exhaustive information would be. 
So: is partially exhaustive auxiliary information two- or three-phase?


##  Is Partially Exhaustive Auxiliary Information Two- or Three-Phase?


The (first) estimation given on page 22 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf) is:

``` {r}
extsynth_3p <- threephase(formula.s0, formula.s1, data = grisons,
                          phase_id = list(phase.col = "phase_id_3p",
                                          s1.id = 1, terrgrid.id = 2),
                          small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                            unbiased = TRUE),
                          exhaustive = truemeans.G,
                          boundary_weights = "boundary_weights"
                          )
extsynth_3p$estimation
```

``` {r}
s12_3p$s1 <- NULL
s12_3p$phase_id_2p <- NULL
s12_3p$phase_id_3p <- NULL
maSAE <- predict(saObj(data = s12_3p, 
                       f = update(formula.s1, ~ . | smallarea),
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2', smallAreaMeans = tm)
)
compare(maSAE, extsynth_3p, "three-phase, ext. sae")

```

So this is a two-phase setup, `forestinventory` seems to need the three-phase setup (the reduced model)
to identify the partially exhaustive part of the auxiliary information. 
The corresponding publication is 

  Daniel Mandallaz, Jochen Breschan, and Andreas Hill. New regression
  estimators in forest inventories with two-phase sampling and partially
  exhaustive information: a design-based Monte Carlo approach with applications
  to small-area estimation.
  In: Canadian Journal of Forest Research 43.11 (2013), pp. 1023-1031.
  doi: 10.1139/cjfr-2013-0181.



The benchmarks again:

``` {r}
mb <- mbmb(
           forestinventory = wrap_three(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                                unbiased = TRUE),
                              exhaustive = truemeans.G),
           maSAE = predict(suppressMessages(saObj(data = s12_3p, 
                       f = update(formula.s1, ~ . | smallarea),
                       s2 = 's2', smallAreaMeans = tm)))[, -1],
           check = "equivalent")
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)

```


# Cluster Sampling

I adapt data from `maSAE` to  section 6.2 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf):

``` {r}

suppressWarnings(rm("s1" ,"s2", "s12"))
data("s1", "s2", package = "maSAE")
s12 <- bind_data(s1, s2)
# adapt for forestinventory
s12[["g"]][is.na(s12[["g"]])] <- "a"
s12[["phase"]]  <-  s12[["phase1"]] + s12[["phase2"]]
maSAE <- predict(suppressMessages(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", cluster = "clustid")))
extpsynth.clust <- twophase(y ~x1 + x2 + x3,
         data = s12,
         cluster = "clustid",
         phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
         small_area = list(sa.col = "g", areas = c("a", "b"),
                           unbiased = TRUE))
compare(maSAE, extpsynth.clust, "three-phase, ext. sae")
mb <- mbmb(
           forestinventory = clean(twophase(y ~x1 + x2 + x3,
         data = s12,
         cluster = "clustid",
         phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
         small_area = list(sa.col = "g", areas = c("a", "b"),
                           unbiased = TRUE))),
           maSAE = clean(predict(suppressMessages(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", cluster = "clustid")))),

           check = "equivalent")
print(mb)
microbenchmark:::autoplot.microbenchmark(mb)

```

Now I use the example given in  section 6.2 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf):

``` {r}
  data("zberg", package = "forestinventory")
  forestinventory <- forestinventory::twophase(
    formula = basal ~ stade + couver + melange, data = zberg,
    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
    cluster = "cluster",
    small_area = list(
      sa.col = "ismallold", areas = c("1"),
      unbiased = TRUE
    )
  )
  s1 <- zberg[zberg[["phase_id_2p"]] == 1, ]
  s2 <- zberg[zberg[["phase_id_2p"]] == 2, ]
  s12 <- rbind(s1, s2)
  s12[["s1"]] <- s12[["phase_id_2p"]] %in% c(1, 2)
  s12[["s2"]] <- s12[["phase_id_2p"]] == 2
  object <- maSAE::saObj(
    data = s12,
    f = basal ~ stade + couver + melange | ismallold,
    s2 = "s2",
    cluster = "cluster"
  )
  maSAE <- maSAE::predict(object)
  compare(maSAE[2,], forestinventory, "clustered, ext. sae")
```
Obviously, something went wrong. The difference to the previous example? `zberg` contains nominally scaled predictors.
If I ignore the cluster design, both packages give the same result:

``` {r}
  forestinventory <- forestinventory::twophase(
    formula = basal ~ stade + couver + melange, data = zberg,
    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
    small_area = list(
      sa.col = "ismallold", areas = c("1"),
      unbiased = TRUE
    )
  )
  object <- maSAE::saObj(
    data = s12,
    f = basal ~ stade + couver + melange | ismallold,
    s2 = "s2",
  )
  maSAE <- maSAE::predict(object)
  compare(maSAE[2,], forestinventory, "clustered, ext. sae")
```

I do not know where that comes from. But since `maSAE` has very structured code compared to `forestinventory`
(`maSAE` needs about 500 lines of code for its prediction functions, `forestinventory` more than 2200), I am biased to
believe `maSAE`.


# Conclusion
- Both packages give mostly identical results, but different ones for clustered sampling designs with nominally scaled predictors.
- `forestinventory` views partially exhaustive auxiliary information as a
three-phase setup, `maSAE` (following Mandallaz' publications) uses a two-phase setup, but both packages give identical results after some data tweaking.
- `maSAE` seems to be a bit faster.
- `forestinventory` has global estimators implemented.

---
title: "A Comparison of maSAE to forestinventory"
author: 
date: 2020-03-13, 13:16:56
output: rmarkdown::html_vignette
vignette: >
  %\VignetteIndexEntry{A Comparison of maSAE to forestinventory}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}
---

# What is this about?

In 2016, Andreas Hill published package 
[forestinventory](https://CRAN.R-project.org/package=forestinventory).
We thought about merging the packages, but never actually got to it: 
`maSAE` is S4, `forestinventory` is S3, both of us are busy doing other stuff.
So I am trying to at least compare functionality of both packages.


```r
library("forestinventory")
library("maSAE")
```

```
## 
## Attaching package: 'maSAE'
```

```
## The following object is masked from 'package:stats':
## 
##     predict
```

# Setup

I need some helpers for checking and comparing results from 
`maSAE` and `forestinventory`:



```r
clean <- function(x, which = NULL) {
    if (identical(FALSE, which)) {
        res <- as.matrix(unname(x[TRUE, TRUE]))
    } else {
        if (is.null(which)) {
            if (all(c( "small_area", "prediction", "variance") %in% names(x))) {
                res <- as.matrix(unname(x[TRUE, 1:3]))
            } else {
                res <- as.matrix(unname(x[["estimation"]][TRUE, c("area", "estimate", "g_variance")]))
            }
        } else {
            res <- as.matrix(unname(x[TRUE, c(1, grep(which, names(x)))]))
        }
    }
    return(res)
} 

compare <- function(maSAE, forestinventory, message = NULL) {
    if(! isTRUE(all.equal(clean(maSAE), clean(forestinventory), 
                          check.attributes = FALSE))) {
        message <- c("Differing results from maSAE and forestinventory: ", 
                     message)
        warning(message)
        return(FALSE)
    } 
    return(TRUE)
}
```

I use the grisons data set from `forestinventory`:


```r
data(grisons, package = "forestinventory")
```

I define regression models for simple and cluster sampling:


```r
formula.s0 <- tvol ~ mean # reduced model:
formula.s1 <- tvol ~ mean + stddev + max + q75 # full model
formula.clust.s0 <- basal ~ stade
formula.clust.s1 <- basal ~ stade + couver + melange
```

# Two-Phase 
Some data handling,
true means are taken from 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf). :


```r
truemeans.G <- data.frame(Intercept = rep(1, 4),
                          mean = c(12.85, 12.21, 9.33, 10.45),
                          stddev = c(9.31, 9.47, 7.90, 8.36),
                          max = c(34.92, 35.36, 28.81, 30.22),
                          q75 = c(19.77, 19.16, 15.40, 16.91))
rownames(truemeans.G) <- c("A", "B", "C", "D")

# data adjustments
s1 <- grisons[grisons[["phase_id_2p"]] == 1, ]
s2 <- grisons[grisons[["phase_id_2p"]] == 2, ]
s12 <- rbind(s1, s2)
s12$s1 <- s12$phase_id_2p %in% c(1, 2)
s12$s2 <- s12$phase_id_2p == 2

tm <- truemeans.G
tm[["smallarea"]] <- row.names(tm)
tm[["Intercept"]] <- NULL

truemeans.G.partially <- truemeans.G[, -which(names(truemeans.G) %in% c("stddev", "mean"))]
tm.partially <- tm[, -which(names(tm) %in% c("stddev", "mean"))]
```

##  No Exhaustive Auxiliary Information

This is the estimation given on bottom of page 15 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf):

```r
summary(twophase(formula = formula.s1, 
                 data = grisons,
                 phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                 small_area = list(sa.col = "smallarea", 
                                   areas = c("A", "B","C", "D"),
                                   unbiased = TRUE),
                 boundary_weights = "boundary_weights"
                 ))
```

```
## 
## Two-phase small area estimation
##  
## Call: 
## twophase(formula = formula.s1, data = grisons, phase_id = list(phase.col = "phase_id_2p", 
##     terrgrid.id = 2), small_area = list(sa.col = "smallarea", 
##     areas = c("A", "B", "C", "D"), unbiased = TRUE), boundary_weights = "boundary_weights")
## 
## Method used:
## Extended pseudosynthetic small area estimator
##  
## Regression Model:
## tvol ~ mean + stddev + max + q75 + smallarea
## 
## Estimation results:
##  area estimate ext_variance g_variance  n1 n2 n1G n2G r.squared
##     A 391.9356     995.5602   1017.633 306 67  94  19 0.6526503
##     B 419.7231    1214.6053   1019.191 306 67  81  17 0.6428854
##     C 328.8600     916.2266   1036.791 306 67  66  15 0.6430018
##     D 373.9497    1272.7056   1110.245 306 67  65  16 0.6556178
## 
## 'boundary_weight'- option was used to calculate weighted means of auxiliary variables
```
Now I`m using both packages to make predictions:


```r
maSAE <- predict(saObj(data = s12,
                       f = update(formula.s1, ~ . | smallarea),
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2')
)

forestinventory <- twophase(formula = formula.s1, 
                            data = grisons,
                            phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                            small_area = list(sa.col = "smallarea", 
                                              areas = c("A", "B","C", "D"),
                                              unbiased = TRUE),
                            boundary_weights = "boundary_weights"
                            )
```

Both packages deliver the same results:


```r
compare(maSAE, forestinventory, "two-phase, ext. pseudo sae")
```

```
## [1] TRUE
```

Now I benchmark them, calculating the small, synthetic and extended synthetic estimators:

```r
wrap_two <- function(...) {
    dots <- list(...)
    dots$small_area$unbiased <- TRUE
    ex <- do.call(twophase, dots)$estimation
    dots$psmall <- TRUE
    small <- do.call(twophase, dots)$estimation
    dots$psmall <- FALSE
    dots$small_area$unbiased <- FALSE
    synth <- do.call(twophase, dots)$estimation
    cbind(ex[TRUE, c("estimate", "g_variance")], 
          synth[TRUE, c("estimate", "g_variance")], 
          small[TRUE, c("estimate", "g_variance")])

}
mbmb <- microbenchmark::microbenchmark
mb <- mbmb(
           forestinventory = wrap_two(formula = formula.s1, 
                                    data = grisons,
                                    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
                                    small_area = list(sa.col = "smallarea", 
                                                      areas = c("A", "B","C", "D"),
                                                      unbiased = TRUE)
                                    ), 
           maSAE = predict(saObj(data = s12, 
                                 f = update(formula.s1, ~ . | smallarea),
                                 s2 = 's2'
                                 ))[, -1],
           check = "equivalent"
           )
```

`maSAE` seems a bit faster:


```r
print(mb)
```

```
## Unit: milliseconds
##             expr      min        lq      mean    median        uq      max
##  forestinventory 97.92595 103.34740 104.30102 104.62381 105.51717 113.6678
##            maSAE 45.97229  46.67169  50.02664  47.14662  52.00644 135.6001
##  neval
##    100
##    100
```

```r
microbenchmark:::autoplot.microbenchmark(mb)
```

```
## Coordinate system already present. Adding new coordinate system, which will replace the existing one.
```

![plot of chunk unnamed-chunk-10](figure/unnamed-chunk-10-1.png)


##  Full Exhaustive Auxiliary Information
The estimation given on page 17 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf) is
 (there are no boundary weights here):


```r
forestinventory <- twophase(formula = formula.s1, 
                            data = grisons,
                            phase_id = list(phase.col = "phase_id_2p", 
                                            terrgrid.id = 2),
                            small_area = list(sa.col ="smallarea", 
                                              areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE),
                            exhaustive = truemeans.G)
summary(forestinventory)
```

```
## 
## Two-phase small area estimation
##  
## Call: 
## twophase(formula = formula.s1, data = grisons, phase_id = list(phase.col = "phase_id_2p", 
##     terrgrid.id = 2), small_area = list(sa.col = "smallarea", 
##     areas = c("A", "B", "C", "D"), unbiased = TRUE), exhaustive = truemeans.G)
## 
## Method used:
## Extended synthetic small area estimator
##  
## Regression Model:
## tvol ~ mean + stddev + max + q75 + smallarea
## 
## Estimation results:
##  area estimate ext_variance g_variance  n1 n2 n1G n2G r.squared
##     A 372.6930     744.3658   696.5739 Inf 67 Inf  19 0.6526503
##     B 387.5116     693.8576   708.1105 Inf 67 Inf  17 0.6428854
##     C 334.8314     838.3953   801.4303 Inf 67 Inf  15 0.6430018
##     D 405.9667     940.3149   890.9536 Inf 67 Inf  16 0.6556178
```

Again, predictions from both packages are identical:



```r
maSAE <- predict(saObj(data = s12, 
                       f = update(formula.s1, ~ . | smallarea),
                       s2 = 's2',
                       smallAreaMeans = tm))
compare(maSAE, forestinventory, "two-phase, ext. sae")
```

```
## [1] TRUE
```
The benchmarks again:


```r
mb <- mbmb(
           forestinventory = wrap_two(formula = formula.s1, 
                                            data = grisons,
                                            phase_id = list(phase.col = "phase_id_2p", 
                                                            terrgrid.id = 2),
                                            small_area = list(sa.col ="smallarea", 
                                                              areas = c("A", "B", "C", "D"),
                                                              unbiased = TRUE),
                                            exhaustive = truemeans.G),
           maSAE = predict(saObj(data = s12, 
                                       f = update(formula.s1, ~ . | smallarea),
                                       s2 = 's2',
                                       smallAreaMeans = tm))[, -1],

           check = "equivalent")
print(mb)
```

```
## Unit: milliseconds
##             expr      min       lq    mean   median       uq      max neval
##  forestinventory 76.08331 76.55721 79.9568 79.05417 81.67100 97.34158   100
##            maSAE 44.94283 45.41554 47.4803 45.80962 50.31489 60.02507   100
```

```r
microbenchmark:::autoplot.microbenchmark(mb)
```

```
## Coordinate system already present. Adding new coordinate system, which will replace the existing one.
```

![plot of chunk unnamed-chunk-13](figure/unnamed-chunk-13-1.png)


# Three-Phase
Some data handling,
true means are taken from 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf). :

```r
truemeans.G <- data.frame(Intercept = rep(1, 4),
                          mean = c(12.85, 12.21, 9.33, 10.45))
rownames(truemeans.G) <- c("A", "B", "C", "D")

## data adjustments
s12_3p <- grisons[grisons[["phase_id_3p"]] %in% c(1,2), ]
s0 <- grisons[grisons[["phase_id_3p"]] ==0 , ]
s12_3p$s1 <- s12_3p$phase_id_3p %in% c(1, 2)
s12_3p$s2 <- s12_3p$phase_id_3p == 2
s0$s1 <- s0$s2 <- FALSE
predictors_s0 <- all.vars(formula.s0)[-1]
predictors_s1 <- all.vars(formula.s1)[-1]
eval(parse(text=(paste0("s0$",
                        setdiff(predictors_s1, predictors_s0),
                        " <- NA"))))
s012 <- rbind(s0, s12_3p)
tm <- truemeans.G
tm[["smallarea"]] <- row.names(tm)
tm[["Intercept"]] <- NULL
```

##  No Exhaustive Auxiliary Information

The estimation given on page 23 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf) is:


```r
summary(threephase(formula.s0,
                   formula.s1,
                   data = grisons,
                   phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                   small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                   unbiased = TRUE),
                   boundary_weights = "boundary_weights"
                   ))
```

```
## 
## Three-phase small area estimation
##  
## Call: 
## threephase(formula.s0 = formula.s0, formula.s1 = formula.s1, 
##     data = grisons, phase_id = list(phase.col = "phase_id_3p", 
##         s1.id = 1, terrgrid.id = 2), small_area = list(sa.col = "smallarea", 
##         areas = c("A", "B", "C", "D"), unbiased = TRUE), boundary_weights = "boundary_weights")
## 
## Method used:
## Extended pseudosynthetic small area estimator
##  
## Full Regression Model:
## tvol ~ mean + stddev + max + q75 + smallarea
## 
## Reduced Regression Model:
## tvol ~ mean + smallarea
## 
## Estimation results:
##  area estimate ext_variance g_variance  n0  n1 n2 n0G n1G n2G r.squared_reduced
##     A 395.1882    1901.2107  1858.2042 306 128 40  94  38  12         0.5454824
##     B 389.8329    1846.9952  1816.6552 306 128 40  81  34  11         0.5354637
##     C 321.9967     722.7413   763.0731 306 128 40  66  28   8         0.5282291
##     D 365.4938    2248.9395  1930.6881 306 128 40  65  28   9         0.5339996
##  r.squared_full
##       0.7242913
##       0.7171512
##       0.7172375
##       0.7268820
## 
## 'boundary_weight'- option was used to calculate weighted means of auxiliary variables
```
_Wait, the `ext_variance` differs, but that`s a problem with `forestinventory`..._

I make predictions omitting the boundary weights:


```r
forestinventory <- threephase(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE),
                              boundary_weights = "boundary_weights"
                              )

maSAE <- predict(saObj(data = s012, 
                       f = update(formula.s1, ~ . | smallarea),
                       s1 = 's1',
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2'))
```

```
## n(s0) >> n(s1) should hold, but you've given s1 resulting in n(s1)/n(s0) =  0.418300653594771
```


```r
compare(maSAE, forestinventory, "three-phase, ext. pseudo sae")
```

```
## [1] TRUE
```
The benchmarks again:


```r
wrap_three <- function(...) {
    dots <- list(...)
    dots$small_area$unbiased <- TRUE
    ex <- do.call(threephase, dots)$estimation
    dots$psmall <- TRUE
    small <- do.call(threephase, dots)$estimation
    dots$psmall <- FALSE
    dots$small_area$unbiased <- FALSE
    synth <- do.call(threephase, dots)$estimation
    cbind(ex[TRUE, c("estimate", "g_variance")], 
          synth[TRUE, c("estimate", "g_variance")], 
          small[TRUE, c("estimate", "g_variance")])

}
mb <- mbmb(
           forestinventory = wrap_three(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area=list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                              unbiased = TRUE)
                              ),
           maSAE = predict(suppressMessages(saObj(data = s012, 
                       f = update(formula.s1, ~ . | smallarea),
                       s1 = 's1',
                       s2 = 's2')))[, -1],

           check = "equivalent")
print(mb)
```

```
## Unit: milliseconds
##             expr       min        lq      mean   median        uq      max
##  forestinventory 159.44565 161.90249 171.72479 164.2284 170.83930 273.7904
##            maSAE  75.77113  76.54066  84.85302  81.4385  84.94317 182.1175
##  neval
##    100
##    100
```

```r
microbenchmark:::autoplot.microbenchmark(mb)
```

```
## Coordinate system already present. Adding new coordinate system, which will replace the existing one.
```

![plot of chunk unnamed-chunk-18](figure/unnamed-chunk-18-1.png)

# Partially Exhaustive Auxiliary Information
Funny: `forestinventory` can`t deal with partially exhaustive auxiliary information for two-phase sampling:


```r
try(twophase(formula = formula.s1, 
             data = grisons,
             phase_id = list(phase.col = "phase_id_2p", 
                             terrgrid.id = 2),
             small_area = list(sa.col ="smallarea", 
                               areas = c("A", "B", "C", "D"),
                               unbiased = TRUE),
             exhaustive = truemeans.G.partially))
```

```
## Error in names(Z_bar_1G) <- colnames(design_matrix.s2) : 
##   'names' attribute [6] must be the same length as the vector [4]
```

```r
predict(saObj(data = s12, 
              f = update(formula.s1, ~ . | smallarea),
              s2 = 's2',
              smallAreaMeans = tm.partially))
```

```
##   small_area prediction variance   psynth var_psynth   psmall var_psmall
## 1          A   371.0402 712.3895 401.8953   287.3151 373.9803  1048.5674
## 2          B   398.9159 944.4190 398.5562   303.4478 399.4579   996.5841
## 3          C   330.4869 863.1605 334.5188   261.8389 330.6825  1104.9620
## 4          D   384.7398 999.1490 345.1298   227.8379 380.9174  1203.8859
```
Whereas `maSAE` can`t deal with partially exhaustive auxiliary information for three-phase sampling:

```r
summary(forestinventory <- threephase(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                                unbiased = TRUE),
                              exhaustive = truemeans.G))
```

```
## 
## Three-phase small area estimation
##  
## Call: 
## threephase(formula.s0 = formula.s0, formula.s1 = formula.s1, 
##     data = grisons, phase_id = list(phase.col = "phase_id_3p", 
##         s1.id = 1, terrgrid.id = 2), small_area = list(sa.col = "smallarea", 
##         areas = c("A", "B", "C", "D"), unbiased = TRUE), exhaustive = truemeans.G)
## 
## Method used:
## Extended synthetic small area estimator
##  
## Full Regression Model:
## tvol ~ mean + stddev + max + q75 + smallarea
## 
## Reduced Regression Model:
## tvol ~ mean + smallarea
## 
## Estimation results:
##  area estimate ext_variance g_variance  n0  n1 n2 n0G n1G n2G r.squared_reduced
##     A 380.7982    1642.0551  1524.8061 Inf 128 40 Inf  38  12         0.5454824
##     B 368.8658    1501.2108  1530.6216 Inf 128 40 Inf  34  11         0.5354637
##     C 325.7081     640.2232   541.0235 Inf 128 40 Inf  28   8         0.5282291
##     D 389.3585    1961.1322  1753.9986 Inf 128 40 Inf  28   9         0.5339996
##  r.squared_full
##       0.7242913
##       0.7171512
##       0.7172375
##       0.7268820
```

```r
try(predict(saObj(data = s012, 
              f = update(formula.s1, ~ . | smallarea),
              s2 = 's2',
              s1 = 's1',
              smallAreaMeans = tm)))
```

```
## n(s0) >> n(s1) should hold, but you've given s1 resulting in n(s1)/n(s0) =  0.418300653594771
```

```
## Error in h(simpleError(msg, call)) : 
##   error in evaluating the argument 'object' in selecting a method for function 'predict': invalid class "saeObj" object: Got both partial true means and s1. There is no theoretical description for this so far!
```
I do not see what three-phase partially exhaustive information would be. 
So: is partially exhaustive auxiliary information two- or three-phase?


##  Is Partially Exhaustive Auxiliary Information Two- or Three-Phase?


The (first) estimation given on page 22 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf) is:


```r
extsynth_3p <- threephase(formula.s0, formula.s1, data = grisons,
                          phase_id = list(phase.col = "phase_id_3p",
                                          s1.id = 1, terrgrid.id = 2),
                          small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                            unbiased = TRUE),
                          exhaustive = truemeans.G,
                          boundary_weights = "boundary_weights"
                          )
extsynth_3p$estimation
```

```
##   area estimate ext_variance g_variance  n0  n1 n2 n0G n1G n2G
## 1    A 382.6405    1642.0551  1518.7407 Inf 128 40 Inf  38  12
## 2    B 368.9013    1501.2108  1530.5759 Inf 128 40 Inf  34  11
## 3    C 325.3720     640.2232   543.2681 Inf 128 40 Inf  28   8
## 4    D 388.0325    1961.1322  1756.0906 Inf 128 40 Inf  28   9
##   r.squared_reduced r.squared_full
## 1         0.5454824      0.7242913
## 2         0.5354637      0.7171512
## 3         0.5282291      0.7172375
## 4         0.5339996      0.7268820
```


```r
s12_3p$s1 <- NULL
s12_3p$phase_id_2p <- NULL
s12_3p$phase_id_3p <- NULL
maSAE <- predict(saObj(data = s12_3p, 
                       f = update(formula.s1, ~ . | smallarea),
                       auxiliaryWeights = "boundary_weights",
                       s2 = 's2', smallAreaMeans = tm)
)
compare(maSAE, extsynth_3p, "three-phase, ext. sae")
```

```
## [1] TRUE
```

So this is a two-phase setup, `forestinventory` seems to need the three-phase setup (the reduced model)
to identify the partially exhaustive part of the auxiliary information. 
The corresponding publication is 

  Daniel Mandallaz, Jochen Breschan, and Andreas Hill. New regression
  estimators in forest inventories with two-phase sampling and partially
  exhaustive information: a design-based Monte Carlo approach with applications
  to small-area estimation.
  In: Canadian Journal of Forest Research 43.11 (2013), pp. 1023-1031.
  doi: 10.1139/cjfr-2013-0181.



The benchmarks again:


```r
mb <- mbmb(
           forestinventory = wrap_three(formula.s0,
                              formula.s1,
                              data = grisons,
                              phase_id = list(phase.col = "phase_id_3p", s1.id = 1, terrgrid.id = 2),
                              small_area = list(sa.col = "smallarea", areas = c("A", "B", "C", "D"),
                                                unbiased = TRUE),
                              exhaustive = truemeans.G),
           maSAE = predict(suppressMessages(saObj(data = s12_3p, 
                       f = update(formula.s1, ~ . | smallarea),
                       s2 = 's2', smallAreaMeans = tm)))[, -1],
           check = "equivalent")
print(mb)
```

```
## Unit: milliseconds
##             expr       min        lq      mean   median        uq      max
##  forestinventory 145.82435 151.61332 156.43893 153.6374 156.02328 241.1349
##            maSAE  73.76072  74.91871  80.70124  79.3338  82.17948 176.2857
##  neval
##    100
##    100
```

```r
microbenchmark:::autoplot.microbenchmark(mb)
```

```
## Coordinate system already present. Adding new coordinate system, which will replace the existing one.
```

![plot of chunk unnamed-chunk-23](figure/unnamed-chunk-23-1.png)


# Cluster Sampling

I adapt data from `maSAE` to  section 6.2 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf):


```r
suppressWarnings(rm("s1" ,"s2", "s12"))
data("s1", "s2", package = "maSAE")
s12 <- bind_data(s1, s2)
# adapt for forestinventory
s12[["g"]][is.na(s12[["g"]])] <- "a"
s12[["phase"]]  <-  s12[["phase1"]] + s12[["phase2"]]
maSAE <- predict(suppressMessages(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", cluster = "clustid")))
extpsynth.clust <- twophase(y ~x1 + x2 + x3,
         data = s12,
         cluster = "clustid",
         phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
         small_area = list(sa.col = "g", areas = c("a", "b"),
                           unbiased = TRUE))
compare(maSAE, extpsynth.clust, "three-phase, ext. sae")
```

```
## [1] TRUE
```

```r
mb <- mbmb(
           forestinventory = clean(twophase(y ~x1 + x2 + x3,
         data = s12,
         cluster = "clustid",
         phase_id = list(phase.col = "phase", s1.id = 1, terrgrid.id = 2),
         small_area = list(sa.col = "g", areas = c("a", "b"),
                           unbiased = TRUE))),
           maSAE = clean(predict(suppressMessages(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", cluster = "clustid")))),

           check = "equivalent")
print(mb)
```

```
## Unit: milliseconds
##             expr       min        lq      mean    median        uq      max
##  forestinventory 110.36491 115.75560 117.11036 117.44532 118.89882 128.8960
##            maSAE  41.97859  42.53707  45.34768  43.10041  45.23293 148.8214
##  neval
##    100
##    100
```

```r
microbenchmark:::autoplot.microbenchmark(mb)
```

```
## Coordinate system already present. Adding new coordinate system, which will replace the existing one.
```

![plot of chunk unnamed-chunk-24](figure/unnamed-chunk-24-1.png)

Now I use the example given in  section 6.2 of 
[forestinventory`s vignette](https://CRAN.R-project.org/package=forestinventory/vignettes/forestinventory_vignette.pdf):


```r
  data("zberg", package = "forestinventory")
  forestinventory <- forestinventory::twophase(
    formula = basal ~ stade + couver + melange, data = zberg,
    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
    cluster = "cluster",
    small_area = list(
      sa.col = "ismallold", areas = c("1"),
      unbiased = TRUE
    )
  )
```

```
## Warning: At least one terrestrial cluster not entirely included within the small area 1.
## Zero mean residual assumption for small area maybe violated.
## Check mean_Rc_x_hat_G and consider alternative estimator 'psmall'
```

```r
  s1 <- zberg[zberg[["phase_id_2p"]] == 1, ]
  s2 <- zberg[zberg[["phase_id_2p"]] == 2, ]
  s12 <- rbind(s1, s2)
  s12[["s1"]] <- s12[["phase_id_2p"]] %in% c(1, 2)
  s12[["s2"]] <- s12[["phase_id_2p"]] == 2
  object <- maSAE::saObj(
    data = s12,
    f = basal ~ stade + couver + melange | ismallold,
    s2 = "s2",
    cluster = "cluster"
  )
```

```
## include is NULL, automatically adding it as TRUE to data.
```

```r
  maSAE <- maSAE::predict(object)
  compare(maSAE[2,], forestinventory, "clustered, ext. sae")
```

```
## Warning in compare(maSAE[2, ], forestinventory, "clustered, ext. sae"):
## Differing results from maSAE and forestinventory: clustered, ext. sae
```

```
## [1] FALSE
```
Obviously, something went wrong. The difference to the previous example? `zberg` contains nominally scaled predictors.
If I ignore the cluster design, both packages give the same result:


```r
  forestinventory <- forestinventory::twophase(
    formula = basal ~ stade + couver + melange, data = zberg,
    phase_id = list(phase.col = "phase_id_2p", terrgrid.id = 2),
    small_area = list(
      sa.col = "ismallold", areas = c("1"),
      unbiased = TRUE
    )
  )
  object <- maSAE::saObj(
    data = s12,
    f = basal ~ stade + couver + melange | ismallold,
    s2 = "s2",
  )
  maSAE <- maSAE::predict(object)
  compare(maSAE[2,], forestinventory, "clustered, ext. sae")
```

```
## [1] TRUE
```

I do not know where that comes from. But since `maSAE` has very structured code compared to `forestinventory`
(`maSAE` needs about 500 lines of code for its prediction functions, `forestinventory` more than 2200), I am biased to
believe `maSAE`.


# Conclusion
- Both packages give mostly identical results, but different ones for clustered sampling designs with nominally scaled predictors.
- `forestinventory` views partially exhaustive auxiliary information as a
three-phase setup, `maSAE` (following Mandallaz' publications) uses a two-phase setup, but both packages give identical results after some data tweaking.
- `maSAE` seems to be a bit faster.
- `forestinventory` has global estimators implemented.

%\VignetteIndexEntry{Mandallaz' model-assisted small area estimators}
\documentclass[a4paper]{article}
\bibliographystyle{unsrt}
\usepackage[usenames,dvipsnames]{color}
\usepackage{listings}
\lstset{ %
basicstyle=\footnotesize
, commentstyle=\color{PineGreen}
, numberstyle=\tiny\color{Gray}
, rulecolor=\color{Black}
, keywordstyle=\color{Blue}
, stringstyle=\color{Sepia}
, showstringspaces=false
, language=R
}
\usepackage[utf8]{inputenc}
\title{Mandallaz' Model-Assisted Small Area Estimators}
\author{Andreas Dominik Cullmann}

\SweaveOpts{echo=false}
\SweaveOpts{eval=false}
\SweaveOpts{print=false}
\SweaveOpts{width=60}
\begin{document}
\maketitle
\providecommand{\rpack}[1]{package \texttt{#1}}
\providecommand{\rdata}[1]{\texttt{#1}}
\providecommand{\rcode}[1]{\texttt{#1}}
\section{Introduction}
Model-\emph{based} small area estimators (for example \cite{rao2003}, chapters 5ff.)
depend on model assumptions to hold. This dependency doesn't make them very attractive
for official statistics. 

Model-\emph{assisted} small area estimators do not depend on the model assumptions to hold,
albeit their variances will be higher if the model is inappropriate (see
\cite{saerndal1992}, chapter 6.7). The synthetic-regression estimator (SRE) (for example
\cite{rao2003}, chapter 4.2.2) is biased, and the variance of its biased-corrected version,
the generalized regression estimator (for example \cite{rao2003}, chapter 2.5),
``depends crucially on the [\ldots{}] residuals in the small area''
(\cite{mandallaz2013a2}, p. 444), which basically means that its variance will be
unacceptably high in many applications.

Daniel Mandallaz and others (
\cite{mandallaz2012a1}, 
\cite{mandallaz2013a2}, 
\cite{mandallaz2013b2}, 
\cite{mandallaz2013b1}, 
\cite{mandallaz2014c2} and
\cite{mandallaz2013c1} 
)
propose an unbiased extension of the SRE for two- and
three-phase sampling designs with or without clustering. The variance of the  extended 
SRE is, like that of the SRE, based on all residuals in the second (or third) phase 
and asymptotically equivalent to the SRE's variance (see \cite{mandallaz2013a2}, p.~444).

\section{Non-Exhaustive Auxiliary Information}
\subsection{Two-Phase Sampling}
<<eval=true>>==
library("maSAE")
@
Let us suppose we have a two-phase sampling design, and the sample data can be loaded
via 
<<echo=true, eval=true>>==
data("s2")
data("s1")
@
We now add sampling phase indicators to the data and join (from a database point of view
we do a union, but I'll keep calling it join) it into a single data.frame
\rcode{s12}:
<<echo=true, eval=true>>==
s12 <- bind_data(s1, s2)
@
We build a small area Object
<<echo=true, eval=true>>==
saeO <- saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2")
@
and get the small area estimations for the non-exhaustive case as
<<echo=true, eval=true>>==
predict(saeO)
@

\subsection{Three-Phase Sampling}
Suddenly we stumble across data from a  third sampling phase, the null phase (\rdata{s0} has
all the predictors of \rdata{s2}, but we keep only one -- if we kept all of them, we'ld
be back to two-phase sampling with more observations), and we join all three phases 
into \rdata{s012}:
<<echo=true, eval=true>>==
data("s0")
s0$x1 <- s0$x3 <- NULL
s012 <- bind_data(s1, s2, s0)
@
from which we predict again: 
<<echo=true, eval=true>>==
predict(saObj(data = s012,  f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", s1 = "phase1"))
@
Note the drop in variance induced by the extensive null phase sampling.

\section{Partially Exhaustive Auxiliary Information}
Let us suppose we \emph{knew} the estimated small area means  of the fixed effect 
sampled in all three phases to be the true small area means:
<<echo=true, eval=true>>==
tm1 <- as.data.frame(tapply(s012$x2, s012$g, mean))
names(tm1)[1] <- c("x2"); tm1$g <- row.names(tm1)
predict(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", smallAreaMeans = tm1))
@
Again, the variance estimation is reduced, but not as markedly as before: due to
the extensive null phase the mean estimations had very small variances (which added to the
small area estimation variances).
\section{Exhaustive Auxiliary Information}
Of course we could also take our estimated small area means of all fixed effects 
from the first and second phase to be the true means:
<<echo=true, eval=true>>==
preds <- paste("x",1:3, sep="")
tm <- as.data.frame(rbind(colMeans(subset(s12, g == "a")[, preds]),
                          colMeans(subset(s12, g == "b")[, preds])
                          )
); tm$g=c("a", "b")
@
That would give us the smallest variance estimates:
<<echo=true, eval=true>>==
predict(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", smallAreaMeans = tm))
@
\section{Model-Based Small Area Estimation}
\textit{Wait! If I use the code in Appendix  \ref{RAO} to calculate the EBLUP for the basic unit
level model given by \cite{rao2003}, chapter 7.2, I get at least a much smaller mse1:}

<<echo=true, eval=true>>==
source("Rao.R")
library(nlme)
dat <- subset(s2, ! is.na(s2$g))
dat <- dat[with(dat, order(g)), TRUE]
aLmeObj <- lme(y ~x1 + x2 + x3, data = dat, random =  ~1 | g)
foo <- new(Class = "sae", lmeObj = aLmeObj, domain.df = tm)
sae(foo)
@

Of course you do, but you rely on the model's assumptions to hold. Have you checked them?

\textit{ No, I don't even know what they are. But even if the tests would not reject the
hypotheses of the assumptions being valid on, say, a .95 confidence level, I could never
be sure.}\\
That's why I wrote \rcode{maSAE}.\\
\textit{ I see, but wait again, what is \ldots}

\section{Cluster Sampling}
<<echo=true, eval=true>>==
 grep(".*clust", capture.output(str(s1)), value = TRUE)
@
\textit{\ldots this ``clustid'' in the data.frames?}\\
Dear, I forgot that sampling for my completely made up example data 
was done with a cluster design!
So all the above variances estimates are too optimistic. My fault.
For the sake of CPU time on CRAN, I'll leave the following to you:

<<echo=true, eval=false>>==
predict(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", cluster = "clustid"))
@
<<echo=true, eval=false>>==
predict(saObj(data = s012,  f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", s1 = "phase1",
              cluster = "clustid"))
@
<<echo=true, eval=false>>==
predict(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", smallAreaMeans = tm1,
              cluster = "clustid"))
@
<<echo=true, eval=false>>==
predict(saObj(data = s12, f = y ~x1 + x2 + x3 | g,
              s2 = "phase2", smallAreaMeans = tm,
              cluster = "clustid"))
@
\bibliography{bibliography}
\appendix
\section{Rao.R\label{RAO}}
\lstinputlisting{Rao.R}

\end{document}

%\VignetteIndexEntry{Estimators in Detail}
\documentclass[a4paper]{article}
\usepackage{xfrac}
\usepackage{booktabs}
\usepackage{longtable}            
\usepackage{pdflscape}
\usepackage[usenames,dvipsnames]{color}
\usepackage{listings}
\lstset{ %
basicstyle=\footnotesize
, commentstyle=\color{PineGreen}
, numberstyle=\tiny\color{Gray}
, rulecolor=\color{Black}
, keywordstyle=\color{Blue}
, stringstyle=\color{Sepia}
, showstringspaces=false
, language=R
}
\usepackage[utf8]{inputenc}
\title{Estimators in Detail}
\author{Andreas Dominik Cullmann}

\SweaveOpts{echo=false}
\SweaveOpts{eval=false}
\SweaveOpts{print=false}
\SweaveOpts{width=60}
\begin{document}
\maketitle
\providecommand{\rpack}[1]{package \texttt{#1}}
\providecommand{\rdata}[1]{\texttt{#1}}
\providecommand{\rcode}[1]{\texttt{#1}}
\providecommand{\eZ}{\mathcal{Z}}
\providecommand{\strongrule}{\midrule[2pt]}
\providecommand{\lightrule}{\midrule[0.4pt]}
\providecommand{\vR}{\frac{1}{n_{s_2,G}}\hat{V}(\hat{R}_{s_2,G}(x))}
\providecommand{\mR}{\bar{\hat{R}}_{s_2,G}(x)}
\providecommand{\vRc}{\frac{1}{n_{s_2,G}}\hat{V}(\hat{R}_{c,s_2,G}(x))}
\providecommand{\mRc}{\bar{\hat{R}}_{c,s_2,G}(x)}
\section{Introduction}
\paragraph{Superscripts}
For partially exhaustive auxiliary information, 
Mandallaz (\cite[p.~1023]{Man13b}, \cite[p.~383f]{Man13c} defines 
$Z^t(x) = Z^{(1)t}(x)+Z^{(2)t}(x)$ 
whereas Hill \cite[p.~4 and p.~18]{hill2017} defines 
$Z^t(x) = Z^{(0)t}(x)+Z^{(1)t}(x)$.
I will stick with Mandallaz' notation, changing $Z^{(0)t}(x)$ to $Z^{(1)t}(x)$
in Hill's formulae!

\paragraph{Indices}
Mandallaz and Hill inconsistently uses the indices $_2$ and $_{s_2}$,
they really both denote the same: the set
$s_2$.
For the sets $s_0$ and $s_1$ they consistently use $_0$ and $_1$.
I have change all set indices to $s_{[012]}$.



Hill uses $\bar{Z}_{0,G}^{(1)}$ (and $\bar{Z}_{0}^{(1)}$ which
(\cite[p.~18]{hill2017}) is the exact mean). So I do drop the index,
which is misleadingly referring to some set (and I do so for
$\bar{\eZ}_{0,G}^{(1)}$).


Mandallaz uses $\bar{\hat{R}}_{2,G}$ when calculating the variance of the
residuals in G, for example in a2.26, where  $\bar{\hat{R}}_{2,G}$ is clearly
$\bar{\hat{R}}(x)$ while summing over $s_2$ and $G$. I use the latter form.

\paragraph{References}
I reference \cite{Man12a.e} as a1,
\cite{Man13a} as a2,
\cite{Man13b.e} as b1,
\cite{Man13b} as b2,
\cite{Man13c.e} as c1,
\cite{Man13c} as c2 and
\cite{hill2017} as h.




\paragraph{Estimators}

In tables~\ref{tab:unclustered2} and \ref{tab:unclustered3},
we see the estimators for the two- and three-phase non-clustered sampling
designs.
The estimators are grouped by the type of auxiliary information: exhaustive (for
two-phase sampling only, three-phase sampling with full exhaustive auxiliary
information is just two-phase sampling with full exhaustive auxiliary
information with more observations),
non-exhaustive and partially exhaustive.
In each block the (pseudo) synthetic the (pseudo) small and the
(pseudo) extended estimator and their variances are given.

I have replaced
the empirical mean and variance of the Residuals in G for clustered
sampling,
$$\frac{\sum_{x\in s_2,G}{M(x)\hat{R}_c(x)}}{\sum_{x\in s_2,G}{M(x)}}$$
and
$$\frac{1}{n_{s_2,G}-1} \sum_{x\in
s_2,G}{\left(\frac{M(x)}{\bar{M}(x)}\right)^2 (\hat{R}_c(x)
-\bar{\hat{R}}_c(x))^2},$$
by their shorter notations
$\bar{\hat{R}}_{c,s_2,G}(x)$ and 
$\hat{V}(\hat{R}_{c,s_2,G}(x))$
and likewise for non-clustered sampling.


Looking at the estimators for partially exhaustive auxiliary information
we see that the estimators and variances are identical for two- and three-phase sampling.
This is due to the fact that 
\cite{hill2017} implemented the partially exhaustive auxiliary information using
a full and a reduced model. So they see it as three-phase
sampling where \cite{Man13b} clearly see it as two-phase sampling with partially
exhaustive auxiliary information.



Tables~\ref{tab:clustered2} and \ref{tab:clustered3} give the same information for clustered sampling
designs.



{
    \fontsize{8}{11}\selectfont
    \input{unclustered.tex}
    \input{clustered.tex}
}


<<echo=true, eval=true>>==

fake_weights <- function(df) {
    df[["weights"]] <- 1
    df[["weights"]][df[["x2"]] == 0] <- 0.12
    return(df)
}
suppressWarnings(rm(s1, s2, s0))
data("s1", "s2", "s0", package = "maSAE")
s0$x1 <- s0$x3 <- NULL
s0 <- fake_weights(s0)
s1 <- fake_weights(s1)
s2 <- fake_weights(s2)
s12 <- maSAE::bind_data(s1, s2)
s012 <- maSAE::bind_data(s1, s2, s0)
tm <- data.frame(x1 = c(150, 200), x2 = c(23, 23), x3 = c(7, 7.5), g = c("a", "b"))
tm_p <- data.frame(x2 = c(23, 23), g = c("a", "b"))

#% unclustered

##% un-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm_p, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, 
                       s1 = "phase1", s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

#% clustered
##% un-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)


##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
(outlm <- maSAE::predict(object, use_lm = TRUE))
RUnit::checkEquals(out, outlm)


@
\bibliographystyle{unsrt}
\bibliography{bib}

\end{document}

%\VignetteIndexEntry{An Introduction to maSAE}
\documentclass[a4paper]{article}
\usepackage{xfrac}
\usepackage{booktabs}
\usepackage{longtable}            
\usepackage{pdflscape}
\usepackage[usenames,dvipsnames]{color}
\usepackage{listings}
\lstset{ %
basicstyle=\footnotesize
, commentstyle=\color{PineGreen}
, numberstyle=\tiny\color{Gray}
, rulecolor=\color{Black}
, keywordstyle=\color{Blue}
, stringstyle=\color{Sepia}
, showstringspaces=false
, language=R
}
\usepackage[utf8]{inputenc}
\title{An Introduction to maSAE}
\author{Andreas Dominik Cullmann}

\SweaveOpts{echo=false}
\SweaveOpts{eval=false}
\SweaveOpts{print=false}
\SweaveOpts{width=60}
\begin{document}
\maketitle
\providecommand{\rpack}[1]{package \texttt{#1}}
\providecommand{\rdata}[1]{\texttt{#1}}
\providecommand{\rcode}[1]{\texttt{#1}}
\providecommand{\eZ}{\mathcal{Z}}
\providecommand{\strongrule}{\midrule[2pt]}
\providecommand{\lightrule}{\midrule[0.4pt]}
\section{Introduction}
\paragraph{Superscripts}
For partially exhaustive auxiliary information, 
Mandallaz (\cite[p.~1023]{Man13b}, \cite[p.~383f]{Man13c} defines 
$Z^t(x) = Z^{(1)t}(x)+Z^{(2)t}(x)$ 
whereas Hill \cite[p.~4 and p.~18]{hill2017} defines 
$Z^t(x) = Z^{(0)t}(x)+Z^{(1)t}(x)$.
I will stick with Mandallaz' notation, changing $Z^{(0)t}(x)$ to $Z^{(1)t}(x)$
in Hill's formulae!

\paragraph{Indicies}
Mandallaz and Hill inconsistently uses the indices $_2$ and $_{s_2}$,
they really both denote the same: the set
$s_2$.
For the sets $s_0$ and $s_1$ they consistsently use $_0$ and $_1$.
I have change all set indices to $s_{[012]}$.



Hill uses $\bar{Z}_{0,G}^{(1)}$ (and $\bar{Z}_{0}^{(1)}$ which
(\cite[p.~18]{hill2017}) is the exact mean). So I do drop the index,
which is misleadingly refering to some set (and I do so for
$\bar{\eZ}_{0,G}^{(1)}$).


Mandallaz uses $\bar{\hat{R}}_{2,G}$ when calculating the variance of the
residuals in G, for example in a2.26, where  $\bar{\hat{R}}_{2,G}$ is clearly
$\bar{\hat{R}}(x)$ while summing over $s_2$ and $G$. I use the latter form.

\paragraph{References}
I reference \cite{Man12a.e} as a1,
\cite{Man13a} as a2,
\cite{Man13b.e} as b1,
\cite{Man13b} as b2,
\cite{Man13c.e} as c1,
\cite{Man13c} as c2 and
\cite{hill2017} as h.




\paragraph{Estimators}
In tables~\ref{tab:unclustered}  and \ref{tab:clustered} in the first block
there are always the synthetic,
the small area and Mandallaz' extended estimator for different kinds of auxiliary information:
exhaustive, non-exhaustive, partially exhaustive.
In the second block there's the estimators for
three-phase partially exhaustive,
three-phase non-exhaustive
.
Table~\ref{tab:clustered} gives the clustered versions of the estimators in
table~\ref{tab:unclustered}.

Tables~\ref{tab:clusteredcols} and \ref{tab:unclusteredcols} give the same
information in a more compact way, I have replaced
the empirical mean and variance of the Residuals in G for clustered
sampling,
$$\frac{\sum_{x\in s_2,G}{M(x)\hat{R}_c(x)}}{\sum_{x\in s_2,G}{M(x)}}$$
and
$$\frac{1}{n_{s_2,G}-1} \sum_{x\in
s_2,G}{\left(\frac{M(x)}{\bar{M}(x)}\right)^2 (\hat{R}_c(x)
-\bar{\hat{R}}_c(x))^2},$$
by their shorter notations
$\bar{\hat{R}}_{c,s_2,G}(x)$ and 
$\hat{V}(\hat{R}_{c,s_2,G}(x))$
and likewise for unclustered sampling.

Looking at their third blocks (partially exhaustive auxiliary information), 
we see that
the estimators and variances are identical for two- and three-phase sampling.
Yet partially exhaustive auxiliary information is what \cite[p.~22]{hill2017}
uses. To me it seems as useless as exhaustive auxiliary information in
three-phase, which boils down to two-phase with more observations!

{
    \fontsize{8}{11}\selectfont
    \input{unclustered.tex}
    \input{clustered.tex}
\input{cuc.tex}
}


<<echo=true, eval=true>>==

fake_weights <- function(df) {
    df[["weights"]] <- 1
    df[["weights"]][df[["x2"]] == 0] <- 0.12
    return(df)
}
suppressWarnings(rm(s1, s2, s0))
data("s1", "s2", "s0", package = "maSAE")
s0$x1 <- s0$x3 <- NULL
s0 <- fake_weights(s0)
s1 <- fake_weights(s1)
s2 <- fake_weights(s2)
s12 <- maSAE::bind_data(s1, s2)
s012 <- maSAE::bind_data(s1, s2, s0)
tm <- data.frame(x1 = c(150, 200), x2 = c(23, 23), x3 = c(7, 7.5), g = c("a", "b"))
tm_p <- data.frame(x2 = c(23, 23), g = c("a", "b"))

#% unclustered

##% un-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm_p, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, 
                       s1 = "phase1", s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

#% clustered
##% un-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)


##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
(outlm <- maSAE::predict(object, use_lm = TRUE))
RUnit::checkEquals(out, outlm)


@
\bibliographystyle{unsrt}
\bibliography{bib}

\end{document}

%\VignetteIndexEntry{A Taxonomy of Estimators}
\documentclass[a4paper]{article}
\usepackage{xfrac}
\usepackage{booktabs}
\usepackage{longtable}            
\usepackage{pdflscape}
\usepackage[usenames,dvipsnames]{color}
\usepackage{listings}
\lstset{ %
basicstyle=\footnotesize
, commentstyle=\color{PineGreen}
, numberstyle=\tiny\color{Gray}
, rulecolor=\color{Black}
, keywordstyle=\color{Blue}
, stringstyle=\color{Sepia}
, showstringspaces=false
, language=R
}
\usepackage[utf8]{inputenc}
\title{A Taxonomy of Estimators}
\author{Andreas Dominik Cullmann}

\SweaveOpts{echo=false}
\SweaveOpts{eval=false}
\SweaveOpts{print=false}
\SweaveOpts{width=60}
\begin{document}
\maketitle
\providecommand{\analogy}{--}
\providecommand{\rpack}[1]{package \texttt{#1}}
\providecommand{\rdata}[1]{\texttt{#1}}
\providecommand{\rcode}[1]{\texttt{#1}}
\providecommand{\eZ}{\mathcal{Z}}
\providecommand{\strongrule}{\midrule[2pt]}
\providecommand{\lightrule}{\midrule[0.4pt]}
\providecommand{\vR}{\frac{1}{n_{s_2,G}}\hat{V}(\hat{R}_{s_2,G}(x))}
\providecommand{\mR}{\bar{\hat{R}}_{s_2,G}(x)}
\providecommand{\vRc}{\frac{1}{n_{s_2,G}}\hat{V}(\hat{R}_{c,s_2,G}(x))}
\providecommand{\mRc}{\bar{\hat{R}}_{c,s_2,G}(x)}
\section{Introduction}


There is a plentitude of estimators in \cite{Man12a.e},
\cite{Man13a},
\cite{Man13b.e},
\cite{Man13b},
\cite{Man13c.e},
\cite{Man13c} and, finally, 
\cite{hill2017}.

The notation varies, for partially exhaustive auxiliary information, 
the classification given in \cite{hill2017}
even deviates from canon (see \ref{ref:estimators}).

So this is an effort to systematically describe the various small area
estimators.

\paragraph{Superscripts}
For partially exhaustive auxiliary information, 
Mandallaz (\cite[p.~1023]{Man13b}, \cite[p.~383f]{Man13c} defines 
$Z^t(x) = Z^{(1)t}(x)+Z^{(2)t}(x)$ 
whereas Hill \cite[p.~4 and p.~18]{hill2017} defines 
$Z^t(x) = Z^{(0)t}(x)+Z^{(1)t}(x)$.
I will stick with Mandallaz' notation, changing $Z^{(0)t}(x)$ to $Z^{(1)t}(x)$
in Hill's formulae!

\paragraph{Indices}
Mandallaz and Hill inconsistently uses the indices $_2$ and $_{s_2}$,
they really both denote the same: the set
$s_2$.
For the sets $s_0$ and $s_1$ they consistently use $_0$ and $_1$.
I have change all set indices to $s_{[012]}$.



Hill uses $\bar{Z}_{0,G}^{(1)}$ (and $\bar{Z}_{0}^{(1)}$ which
(\cite[p.~18]{hill2017}) is the exact mean). So I do drop the index,
which is misleadingly referring to some set (and I do so for
$\bar{\eZ}_{0,G}^{(1)}$).


Mandallaz uses $\bar{\hat{R}}_{2,G}$ when calculating the variance of the
residuals in G, for example in a2.26, where  $\bar{\hat{R}}_{2,G}$ is clearly
$\bar{\hat{R}}(x)$ while summing over $s_2$ and $G$. I use the latter form.

\paragraph{Residuals}
I have replaced
the empirical mean and variance of the Residuals in G for clustered
sampling,
$$\frac{\sum_{x\in s_2,G}{M(x)\hat{R}_c(x)}}{\sum_{x\in s_2,G}{M(x)}}$$
and
$$\frac{1}{n_{s_2,G}-1} \sum_{x\in
s_2,G}{\left(\frac{M(x)}{\bar{M}(x)}\right)^2 (\hat{R}_c(x)
-\bar{\hat{R}}_c(x))^2},$$
by their shorter notations
$\bar{\hat{R}}_{c,s_2,G}(x)$ and 
$\hat{V}(\hat{R}_{c,s_2,G}(x))$
and likewise for non-clustered sampling.



\section{Estimators\label{sec:estimators}}

In tables~\ref{tab:unclustered2} and \ref{tab:unclustered3},
we see the estimators for the two- and three-phase non-clustered sampling
designs.
The estimators are grouped by the type of auxiliary information: exhaustive (for
 three-phase sampling with full exhaustive auxiliary
information is just two-phase sampling with full exhaustive auxiliary
information with more observations, so there are no estimators),
non-exhaustive and partially exhaustive.
In each block the (pseudo) synthetic the (pseudo) small and the
(pseudo) extended estimator and their variances are given.



Looking at the estimators for partially exhaustive auxiliary information
we see that the estimators and variances are identical for two- and three-phase sampling.
This is due to the fact that 
\cite{hill2017} implement the partially exhaustive auxiliary information using
a full and a reduced model. So they see it as three-phase
sampling where \cite{Man13b} clearly see it as two-phase sampling with partially
exhaustive auxiliary information.



Tables~\ref{tab:clustered2} and \ref{tab:clustered3} give the same information for clustered sampling
designs.



{
    \fontsize{8}{11}\selectfont
    \input{unclustered.tex}
    \input{clustered.tex}
}


\section{R}
<<echo=true, eval=true>>==

fake_weights <- function(df) {
    df[["weights"]] <- 1
    df[["weights"]][df[["x2"]] == 0] <- 0.12
    return(df)
}
suppressWarnings(rm(s1, s2, s0))
data("s1", "s2", "s0", package = "maSAE")
s0$x1 <- s0$x3 <- NULL
s0 <- fake_weights(s0)
s1 <- fake_weights(s1)
s2 <- fake_weights(s2)
s12 <- maSAE::bind_data(s1, s2)
s012 <- maSAE::bind_data(s1, s2, s0)
tm <- data.frame(x1 = c(150, 200), x2 = c(23, 23), x3 = c(7, 7.5), g = c("a", "b"))
tm_p <- data.frame(x2 = c(23, 23), g = c("a", "b"))

#% unclustered

##% non-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm)
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm_p, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", smallAreaMeans = tm, 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, 
                       s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, 
                       s1 = "phase1", s2 = "phase2", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

#% clustered
##% non-weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)


##% weighted
###% two-phase
####% partially exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm_p, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", smallAreaMeans = tm, cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

####% non-exhaustive 
object <- maSAE::saObj(data = s12, f = y ~ x1 + x2 + x3 | g, s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
outlm <- maSAE::predict(object, use_lm = TRUE)
RUnit::checkEquals(out, outlm)

###% three-phase
object <- maSAE::saObj(data = s012, f = y ~ x1 + x2 + x3 | g, s1 = "phase1", s2 = "phase2", cluster = "clustid", 
                       auxiliaryWeights = "weights")
(out <- maSAE::predict(object, use_lm = FALSE))
(outlm <- maSAE::predict(object, use_lm = TRUE))
RUnit::checkEquals(out, outlm)


@
\bibliographystyle{unsrt}
\bibliography{bib}

\end{document}
